unit drawmenu;

interface


uses crt, myutils, prnmenu, submenus, getdrfile;

var
  OrigMode,LastCol,LastRow: Word;
  Ch: Char;
  Done: Boolean;

Procedure drawmainall;
Procedure makewindow;
Procedure initialize;

Implementation



procedure Initialize;
{ Initialize the video mode, LastCol, LastRow }

begin
  CheckBreak:=False;                   { turn off Contrl-C checking }
  OrigMode:=LastMode;                  { Remember original video mode }
  TextMode(CO80);                      { use 43 or 50 lines on EGA/VGA }
  LastCol:=Lo(WindMax)+1;              { get last column, row }
  LastRow:=Hi(WindMax)+1;
end;
  

PROCEDURE DRAWmainMENU;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('          ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(34,4);
    writeln('MAINMENU');
    gotoxy(22,7);                                    {display main options}
    writeln('1: View Employee Profile' );
    gotoxy(22,8);
    writeln('2: Update Employee Info.' );
    gotoxy(22,9);
    writeln('3: Benefits Menu' );
    gotoxy(22,10);
    writeln('4: Time Off Menu' );      {office, driver submenus to be coded}
    gotoxy(22,11);
    writeln('5: Print Menu #1' );
    gotoxy(22,12);
    writeln('6: Print Menu #2' );
    gotoxy(22,13);
    writeln('7: QUIT PROGRAM' );      {office, driver submenus to be coded}

 END;

procedure getoption;

const
 esc = chr(27);                        {escape key active}

var
 ch : char;


begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch := readkey;
  while not (ch in [esc,'1','2','3','4','5','6','7']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
     esc: done := true;

      '1': begin                  { start of view driver profile }
            initialize;
            makewindow;
            getcode;
            makewindow;
            showlist;             {view profile proc}
            drawmainall;             {redraw main menu}
           end;

      '2': begin
            initialize;
            makewindow;
            drawupdate;
            CLRSCR;                    {BENE UPDATE}
                                {ADD!!  BENELIST UPDATE HERE}
            drawmainall;
           end;

      '3': begin
            drawbenall;
            drawmainall;
           end;

      '4': begin;
            drawvacall;
            drawmainall;
           end;

      '5':  begin                     {goto print menu}
            drawprintall;            {redraw main menu}
            drawmainall;
           end;

      '6': begin
            drawprint2all;
            drawmainall;
           end;

      '7': done := true;
 end;
end;



procedure makewindow;
{ Make a window, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol-2);                      {chech screen size}
  Height:=(LastRow-2);
  X:=(0);
  Y:=(0);
  Window(X,Y,X+Width,Y+Height);            {black and white}
  if OrigMode = Mono then
  begin
    TextBackground(White);
    TextColor(Black);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(Black);
    TextColor(White);
  end
  else
  begin
    TextBackground(9);                    {color monitor set purp, black}
    TextColor(11);
    end; { Init }
end; { MakeWindow }

procedure Makeoptionbar;
{ Make a option bar, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol);
  Height:=(LastRow);
  X:=(0);
  Y:=(0);
  if OrigMode = Mono then
  begin
    TextBackground(black);
    TextColor(white);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(white);
    TextColor(black);
  end
  else
  begin
    TextBackground(9);
    TextColor(11);
    window(lastrow-3,0,lastrow,lastcol);
  GoToXY(1,LastRow);                   { put message line on screen }
  Write('      ','Enter Option Number       ',
        '    ESC - ABORT',    '               Memory: ',memavail,'   ');
  Dec(LastRow,80 div LastCol);         { don't write on message line }
  end; { Init }
end; { MakeOptionbar }


PROCEDURE DRAWMAINALL;

begin
  initialize;
  makewindow;
  makeoptionbar;
  drawmainmenu;
  getoption;
end;

end.