unit getdrfile;

interface                             {-----------------------------------}
                                      {all procs for linked structure here}
uses myutils,crt;                     {allows no param passing}
procedure writetofile;                {creates completed data file}
procedure modifylist;                 {all procs global}
procedure benelist;                   {benefits}
procedure getnewemp;                  {get new employee}
procedure readdrfile;                 {all procs must interface}
procedure showlist;                   {display employee general info}
procedure getcode;                    {gets and formats employee code}
procedure delemp1;                    {deletes employee from list}
PROCEDURE BENEDIT;
PROCEDURE DRBRSCR;
const
 maxlines = 200;                     {monitor constant}
                                     {***** DRIVER PROFILE *****}
type                                 {expand to all fields}
 recptr = ^emprec;
 emprec = RECORD
 next      : recptr;
 lastname  : string[20];
 firstname : string[10];
 empcode   : string[6];
 ssnum     : string[9];
 street    : string[20];
 city      : string[20];
 state     : string[2];
 zipcode   : string[5];
 homephone : string[10];
 dob       : string[6];
 emcontact : string[20];
 emphone   : string[10];
 hiredate  : string[6];
 licnum    : string[20];
 licexp    : string[6];
 phexpires : string[6];
 comm1     : string[60];            {profile comments}
 comm2     : string[60];
 comm3     : string[60];
 rehire    : string[3];
 medcst    : string[5];
 mcafe     : string[1];
 dencst    : string[5];              { ALL "...cst" STRINGS ARE BENEFIT $ AMTS  }
 dcafe     : string[1];
 cancst    : string[5];              { ALL "...cafe" STRINGS ARE PRETAXED FLAGS }
 ccafe     : string[1];
 discst    : string[5];
 dicafe    : string[1];
 lifcst    : string[5];
 lcafe     : string[1];
 hoscst    : string[5];
 hcafe     : string[1];
 intcst    : string[5];
 icafe     : string[1];
 foucst    : string[5];
 fcafe     : string[1];
 bcom1     : string[50];              {benefit comments}
 bcom2     : string[50];
 bcom3     : string[50];
end;   {record}
var
 listhead, listtail : recptr;
 linecount : integer;
 proceed : char;
 sfile : text;
 counter : integer;
 line : string[80];
 coded :string[6];
 RCODE : CHAR;

procedure gethead(var head:recptr);

implementation          {-----------------------------------------}

procedure gethead(var head : recptr);

begin
  head := listhead;
end;


procedure drbrscr;                   {draws benefit screen}

 begin
  gotoxy(32,1);
  textcolor(11);
  textbackground(black);
  write('BENEFITS PROFILE');
  gotoxy(1,5);
  writeln('');
  textcolor(15);
  gotoxy(2,3);
  write('Emp Code        :');
  gotoxy(2,4);
  write('Name:           :');
  gotoxy(5,7);
  textcolor(13);
  write('Medical         : $                           Cafe Y/N :');
  gotoxy(5,8);
  textcolor(15);
  write('Dental          : $                           Cafe Y/N : ');
  gotoxy(5,9);
  textcolor(13);
  write('Cancer          : $                           Cafe Y/N : ');
  gotoxy(5,10);
  textcolor(15);
  write('Disability      : $                           Cafe Y/N : ');
  gotoxy(5,11);
  textcolor(13);
  write('Life            : $                           Cafe Y/N : ');
  gotoxy(5,12);
  textcolor(15);
  write('Hospital Income : $                           Cafe Y/N : ');
  gotoxy(5,13);
  textcolor(13);
  write('Intensive Care  : $                           Cafe Y/N : ');
  gotoxy(5,14);
  textcolor(15);
  write('401K            : $                           Cafe Y/N : ');
end;

PROCEDURE BENEDIT;                  {EDITS benefit}

var
 ot,r : char;
 ctr : integer;
 CURRPTR: RECPTR;
 counter,x,mover : integer;
 moretosearch : boolean;
 REP, YNSET, CONT : SET OF CHAR;
 RCODE : CHAR;
 T1, T2, T3 : STRING[1];

begin
 REPEAT
 GETCODE;

 T1:='0';
 T2:='0';
 T3:='0';
 YNSET := ['N','n','Y','y'];
 CONT := ['e','E'];
 REP := ['R','r'];
 currptr := listhead;
 if currptr = NIL then
     begin
     gotoxy(35,2);
     textcolor(28);
     textbackground(black);
     writeln('LIST IS EMPTY');
     textcolor(13);
     end;
 if currptr <> NIL then
      begin
      x:=1;
      gotoxy(7,30);                  {FORMAT SCREEN}
      writeln;
      gotoxy(14,4);
      textbackground(black);
      textcolor(13);
      moretosearch := true;
      while (moretosearch) and (currptr <> NIL) do
        if (currptr^.empcode <> coded) then
         currptr := currptr^.next
         else
         moretosearch := false;
         if currptr^.next <> NIL
         then
          if currptr^.empcode <> coded then
           currptr := NIL;

      if moretosearch <> false then
       begin
         CLRSCR;
         textbackground(black);
         textcolor(13);
         writeln('NOT FOUND....PRESS A KEY TO CONTINUE');
         readkey;
         CLRSCR;
         CTR :=9;
       end
       else
    begin
      gotoxy(20,3);
      textcolor(15);
      write(currptr^.empcode);
       gotoxy(20,4);
         while (currptr^.lastname[x] > chr(47)) and (x<20) do
         begin
         write(currptr^.lastname[x]);
         x:= x+1;
         end;
      gotoxy(19+x,4);
      write(', ');
      write(currptr^.firstname);
      drawcombox;   {comments box}
      drbrscr;                                  {draw screen format}
      textcolor(13);
      gotoxy(25,7);                             {insert info}
      write(currptr^.medcst[1],currptr^.medcst[2],currptr^.medcst[3],'.',currptr^.medcst[4],currptr^.medcst[5]);
      gotoxy(62,7);
      write(currptr^.mcafe);
      gotoxy(25,8);
      textcolor(15);
      write(currptr^.dencst[1],currptr^.dencst[2],currptr^.dencst[3],'.',currptr^.dencst[4],currptr^.dencst[5]);
      gotoxy(62,8);
      write(currptr^.dcafe);
      gotoxy(25,9);
      textcolor(13);
      write(currptr^.cancst[1],currptr^.cancst[2],currptr^.cancst[3],'.',currptr^.cancst[4],currptr^.cancst[5]);
      gotoxy(62,9);
      write(currptr^.ccafe);
      gotoxy(25,10);
      textcolor(15);
      write(currptr^.discst[1],currptr^.discst[2],currptr^.discst[3],'.',currptr^.discst[4],currptr^.discst[5]);
      gotoxy(62,10);
      write(currptr^.dicafe);
      gotoxy(25,11);
      textcolor(13);
      write(currptr^.lifcst[1],currptr^.lifcst[2],currptr^.lifcst[3],'.',currptr^.lifcst[4],currptr^.lifcst[5]);
      gotoxy(62,11);
      write(currptr^.lcafe);
      gotoxy(25,12);
      textcolor(15);
      write(currptr^.hoscst[1],currptr^.hoscst[2],currptr^.hoscst[3],'.',currptr^.hoscst[4],currptr^.hoscst[5]);
      gotoxy(62,12);
      write(currptr^.hcafe);
      gotoxy(25,13);
      textcolor(13);
      write(currptr^.intcst[1],currptr^.intcst[2],currptr^.intcst[3],'.',currptr^.intcst[4],currptr^.intcst[5]);
      gotoxy(62,13);
      write(currptr^.icafe);
      gotoxy(25,14);
      textcolor(15);
      write(currptr^.foucst[1],currptr^.foucst[2],currptr^.foucst[3],'.',currptr^.foucst[4],currptr^.foucst[5]);
      gotoxy(62,14);
      write(currptr^.fcafe);
      gotoxy(30,1);
      textcolor(11);
      gotoxy(9,19);
      write(currptr^.bcom1);
      gotoxy(9,20);
      write(currptr^.bcom2);
      gotoxy(9,21);
      write(currptr^.bcom3);

      CTR :=1;
        GOTOXY(25,7);
        OT := CHR(9);
     END;
        WHILE (OT <> CHR(27)) DO
           BEGIN
           CASE CTR OF

              1: BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,7);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.MEDCST:=('     ');
                 GOTOXY(25,7);
                 CTR := 2;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,7);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,7);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.MEDCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,7);
                          WRITE(CURRPTR^.MEDCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,7);
                       WRITE('      ');
                       GOTOXY(25,7);
                    IF ( COUNTER = 1) THEN
                       CURRPTR^.MEDCST := '     '
                    ELSE
                    IF (CURRPTR^.MEDCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.MEDCST[1]:= CURRPTR^.MEDCST[COUNTER];
                       CURRPTR^.MEDCST[COUNTER]:= ' ';
                       CURRPTR^.MEDCST := ' ';
                       GOTOXY(25,7);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.MEDCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[1];
    {1 DIGITS}         CURRPTR^.MEDCST[1]:= ' ';
                       GOTOXY(25,7);
                       WRITE('    .',CURRPTR^.MEDCST[5])
                       END
                    ELSE IF (CURRPTR^.MEDCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[2];
    {2 DIGITS}         CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       CURRPTR^.MEDCST[2]:= ' ';
                       GOTOXY(25,7);
                       WRITE('   .',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE IF (CURRPTR^.MEDCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[3];
                       CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[2];
    {3 DIGITS}         CURRPTR^.MEDCST[3]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       CURRPTR^.MEDCST[2]:= ' ';
                       GOTOXY(25,7);
                       WRITE('  ',CURRPTR^.MEDCST[3],'.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE IF (CURRPTR^.MEDCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[4];
    {4 DIGITS}         CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[3];
                       CURRPTR^.MEDCST[3]:= CURRPTR^.MEDCST[2];
                       CURRPTR^.MEDCST[2]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       GOTOXY(25,7);
                       WRITE(' ',CURRPTR^.MEDCST[2],CURRPTR^.MEDCST[3],'.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,7);
                       WRITE(CURRPTR^.MEDCST[1],CURRPTR^.MEDCST[2],CURRPTR^.MEDCST[3]);
                       WRITE('.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END;
                   GOTOXY(62,7);
                   write('');
                   GOTOXY(62,7);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.MCAFE := R;
                  GOTOXY(62,7);
                  WRITE(CURRPTR^.MCAFE);
                  counter := 8;
                  END;
                END;
               END
              ELSE
               BEGIN
               OT:= CHR(9);

               CTR:= 2;
               END;
          END;


           2: BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,8);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.DENCST:=('     ');
                 GOTOXY(25,8);
                 CTR := 3;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,8);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,8);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.DENCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,8);
                          WRITE(CURRPTR^.DENCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,8);
                       WRITE('      ');
                       GOTOXY(25,8);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.DENCST := '     '
                    ELSE
                    IF (CURRPTR^.DENCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.DENCST[1]:= CURRPTR^.DENCST[COUNTER];
                       CURRPTR^.DENCST[COUNTER]:= ' ';
                       CURRPTR^.DENCST := ' ';
                       GOTOXY(25,8);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.DENCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[1];
    {1 DIGITS}         CURRPTR^.DENCST[1]:= ' ';
                       GOTOXY(25,8);
                       WRITE('    .',CURRPTR^.DENCST[5])
                       END
                    ELSE IF (CURRPTR^.DENCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[2];
    {2 DIGITS}         CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       CURRPTR^.DENCST[2]:= ' ';
                       GOTOXY(25,8);
                       WRITE('   .',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE IF (CURRPTR^.DENCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[3];
                       CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[2];
    {3 DIGITS}         CURRPTR^.DENCST[3]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       CURRPTR^.DENCST[2]:= ' ';
                       GOTOXY(25,8);
                       WRITE('  ',CURRPTR^.DENCST[3],'.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE IF (CURRPTR^.DENCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[4];
    {4 DIGITS}         CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[3];
                       CURRPTR^.DENCST[3]:= CURRPTR^.DENCST[2];
                       CURRPTR^.DENCST[2]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       GOTOXY(25,8);
                       WRITE(' ',CURRPTR^.DENCST[2],CURRPTR^.DENCST[3],'.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,8);
                       WRITE(CURRPTR^.DENCST[1],CURRPTR^.DENCST[2],CURRPTR^.DENCST[3]);
                       WRITE('.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END;
                   GOTOXY(62,8);
                   write('');
                   GOTOXY(62,8);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.DCAFE := R;
                  GOTOXY(62,8);
                  WRITE(CURRPTR^.DCAFE);
                  counter := 8;
                  END;
                END;
               END
              ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 3;
               END;
          END;





           3 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,9);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.CANCST:=('     ');
                 GOTOXY(25,9);
                 CTR := 4;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,9);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,9);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.CANCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,9);
                          WRITE(CURRPTR^.CANCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,9);
                       WRITE('      ');
                       GOTOXY(25,9);
                     IF ( COUNTER = 1) THEN
                       CURRPTR^.CANCST := '     '
                    ELSE
                    IF (CURRPTR^.CANCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.CANCST[1]:= CURRPTR^.CANCST[COUNTER];
                       CURRPTR^.CANCST[COUNTER]:= ' ';
                       CURRPTR^.CANCST := ' ';
                       GOTOXY(25,9);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.CANCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[1];
    {1 DIGITS}         CURRPTR^.CANCST[1]:= ' ';
                       GOTOXY(25,9);
                       WRITE('    .',CURRPTR^.CANCST[5])
                       END
                    ELSE IF (CURRPTR^.CANCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[2];
    {2 DIGITS}         CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       CURRPTR^.CANCST[2]:= ' ';
                       GOTOXY(25,9);
                       WRITE('   .',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE IF (CURRPTR^.CANCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[3];
                       CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[2];
    {3 DIGITS}         CURRPTR^.CANCST[3]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       CURRPTR^.CANCST[2]:= ' ';
                       GOTOXY(25,9);
                       WRITE('  ',CURRPTR^.CANCST[3],'.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE IF (CURRPTR^.CANCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[4];
    {4 DIGITS}         CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[3];
                       CURRPTR^.CANCST[3]:= CURRPTR^.CANCST[2];
                       CURRPTR^.CANCST[2]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       GOTOXY(25,9);
                       WRITE(' ',CURRPTR^.CANCST[2],CURRPTR^.CANCST[3],'.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,9);
                       WRITE(CURRPTR^.CANCST[1],CURRPTR^.CANCST[2],CURRPTR^.CANCST[3]);
                       WRITE('.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END;
                   GOTOXY(62,9);
                   write('');
                   GOTOXY(62,9);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.CCAFE := R;
                  GOTOXY(62,9);
                  WRITE(CURRPTR^.CCAFE);
                  counter := 8;
                END;
               END;
              END
             ELSE
               BEGIN

               OT:= CHR(9);
               CTR:= 4;
               END;
             END;

            4 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,10);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.DISCST:=('     ');
                 GOTOXY(25,10);
                 CTR := 5;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,10);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,10);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.DISCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,10);
                          WRITE(CURRPTR^.DISCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,10);
                       WRITE('      ');
                       GOTOXY(25,10);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.DISCST := '     '
                    ELSE
                    IF (CURRPTR^.DISCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.DISCST[1]:= CURRPTR^.DISCST[COUNTER];
                       CURRPTR^.DISCST[COUNTER]:= ' ';
                       CURRPTR^.DISCST := ' ';
                       GOTOXY(25,10);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.DISCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[1];
    {1 DIGITS}         CURRPTR^.DISCST[1]:= ' ';
                       GOTOXY(25,10);
                       WRITE('    .',CURRPTR^.DISCST[5])
                       END
                    ELSE IF (CURRPTR^.DISCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[2];
    {2 DIGITS}         CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       CURRPTR^.DISCST[2]:= ' ';
                       GOTOXY(25,10);
                       WRITE('   .',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE IF (CURRPTR^.DISCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[3];
                       CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[2];
    {3 DIGITS}         CURRPTR^.DISCST[3]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       CURRPTR^.DISCST[2]:= ' ';
                       GOTOXY(25,10);
                       WRITE('  ',CURRPTR^.DISCST[3],'.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE IF (CURRPTR^.DISCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[4];
    {4 DIGITS}         CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[3];
                       CURRPTR^.DISCST[3]:= CURRPTR^.DISCST[2];
                       CURRPTR^.DISCST[2]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       GOTOXY(25,10);
                       WRITE(' ',CURRPTR^.DISCST[2],CURRPTR^.DISCST[3],'.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,10);
                       WRITE(CURRPTR^.DISCST[1],CURRPTR^.DISCST[2],CURRPTR^.DISCST[3]);
                       WRITE('.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END;
                   GOTOXY(62,10);
                   write('');
                   GOTOXY(62,10);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.DICAFE := R;
                  GOTOXY(62,10);
                  WRITE(CURRPTR^.DICAFE);
                  counter := 8;
                END;
               END;
              END
             ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 5;
               END;
             END;


           5 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,11);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.LIFCST:=('     ');
                 GOTOXY(25,11);
                 CTR := 6;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,11);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,11);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.LIFCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,11);
                          WRITE(CURRPTR^.LIFCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,11);
                       WRITE('      ');
                       GOTOXY(25,11);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.LIFCST := '     '
                    ELSE
                    IF (CURRPTR^.LIFCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.LIFCST[1]:= CURRPTR^.LIFCST[COUNTER];
                       CURRPTR^.LIFCST[COUNTER]:= ' ';
                       CURRPTR^.LIFCST := ' ';
                       GOTOXY(25,11);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.LIFCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[1];
    {1 DIGITS}         CURRPTR^.LIFCST[1]:= ' ';
                       GOTOXY(25,11);
                       WRITE('    .',CURRPTR^.LIFCST[5])
                       END
                    ELSE IF (CURRPTR^.LIFCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[2];
    {2 DIGITS}         CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       CURRPTR^.LIFCST[2]:= ' ';
                       GOTOXY(25,11);
                       WRITE('   .',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE IF (CURRPTR^.LIFCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[3];
                       CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[2];
    {3 DIGITS}         CURRPTR^.LIFCST[3]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       CURRPTR^.LIFCST[2]:= ' ';
                       GOTOXY(25,11);
                       WRITE('  ',CURRPTR^.LIFCST[3],'.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE IF (CURRPTR^.LIFCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[4];
    {4 DIGITS}         CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[3];
                       CURRPTR^.LIFCST[3]:= CURRPTR^.LIFCST[2];
                       CURRPTR^.LIFCST[2]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       GOTOXY(25,11);
                       WRITE(' ',CURRPTR^.LIFCST[2],CURRPTR^.LIFCST[3],'.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,11);
                       WRITE(CURRPTR^.LIFCST[1],CURRPTR^.LIFCST[2],CURRPTR^.LIFCST[3]);
                       WRITE('.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END;
                   GOTOXY(62,11);
                   write('');
                   GOTOXY(62,11);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.LCAFE := R;
                  GOTOXY(62,11);
                  WRITE(CURRPTR^.LCAFE);
                  counter := 8;
                END;
               END;
              END
             ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 6;
               END;
             END;

           6 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,12);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.HOSCST:=('     ');
                 GOTOXY(25,12);
                 CTR := 7;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,12);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,12);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.HOSCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,12);
                          WRITE(CURRPTR^.HOSCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,12);
                       WRITE('      ');
                       GOTOXY(25,12);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.HOSCST := '     '
                    ELSE
                    IF (CURRPTR^.HOSCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.HOSCST[1]:= CURRPTR^.HOSCST[COUNTER];
                       CURRPTR^.HOSCST[COUNTER]:= ' ';
                       CURRPTR^.HOSCST := ' ';
                       GOTOXY(25,12);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.HOSCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[1];
    {1 DIGITS}         CURRPTR^.HOSCST[1]:= ' ';
                       GOTOXY(25,12);
                       WRITE('    .',CURRPTR^.HOSCST[5])
                       END
                    ELSE IF (CURRPTR^.HOSCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[2];
    {2 DIGITS}         CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       CURRPTR^.HOSCST[2]:= ' ';
                       GOTOXY(25,12);
                       WRITE('   .',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE IF (CURRPTR^.HOSCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[3];
                       CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[2];
    {3 DIGITS}         CURRPTR^.HOSCST[3]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       CURRPTR^.HOSCST[2]:= ' ';
                       GOTOXY(25,12);
                       WRITE('  ',CURRPTR^.HOSCST[3],'.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE IF (CURRPTR^.HOSCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[4];
    {4 DIGITS}         CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[3];
                       CURRPTR^.HOSCST[3]:= CURRPTR^.HOSCST[2];
                       CURRPTR^.HOSCST[2]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       GOTOXY(25,12);
                       WRITE(' ',CURRPTR^.HOSCST[2],CURRPTR^.HOSCST[3],'.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,12);
                       WRITE(CURRPTR^.HOSCST[1],CURRPTR^.HOSCST[2],CURRPTR^.HOSCST[3]);
                       WRITE('.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END;
                   GOTOXY(62,12);
                   write('');
                   GOTOXY(62,12);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.HCAFE := R;
                  GOTOXY(62,12);
                  WRITE(CURRPTR^.HCAFE);
                  counter := 8;
                END;
               END;
              END
             ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 7;
               END;
             END;

           7 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,13);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.INTCST:=('     ');
                 GOTOXY(25,13);
                 CTR := 8;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,13);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,13);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.INTCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,13);
                          WRITE(CURRPTR^.INTCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,13);
                       WRITE('      ');
                       GOTOXY(25,13);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.INTCST := '     '
                    ELSE
                    IF (CURRPTR^.INTCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.INTCST[1]:= CURRPTR^.INTCST[COUNTER];
                       CURRPTR^.INTCST[COUNTER]:= ' ';
                       CURRPTR^.INTCST := ' ';
                       GOTOXY(25,13);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.INTCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[1];
    {1 DIGITS}         CURRPTR^.INTCST[1]:= ' ';
                       GOTOXY(25,13);
                       WRITE('    .',CURRPTR^.INTCST[5])
                       END
                    ELSE IF (CURRPTR^.INTCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[2];
    {2 DIGITS}         CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       CURRPTR^.INTCST[2]:= ' ';
                       GOTOXY(25,13);
                       WRITE('   .',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE IF (CURRPTR^.INTCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[3];
                       CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[2];
    {3 DIGITS}         CURRPTR^.INTCST[3]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       CURRPTR^.INTCST[2]:= ' ';
                       GOTOXY(25,13);
                       WRITE('  ',CURRPTR^.INTCST[3],'.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE IF (CURRPTR^.INTCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[4];
    {4 DIGITS}         CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[3];
                       CURRPTR^.INTCST[3]:= CURRPTR^.INTCST[2];
                       CURRPTR^.INTCST[2]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       GOTOXY(25,13);
                       WRITE(' ',CURRPTR^.INTCST[2],CURRPTR^.INTCST[3],'.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,13);
                       WRITE(CURRPTR^.INTCST[1],CURRPTR^.INTCST[2],CURRPTR^.INTCST[3]);
                       WRITE('.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END;
                   GOTOXY(62,13);
                   write('');
                   GOTOXY(62,13);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.ICAFE := R;
                  GOTOXY(62,13);
                  WRITE(CURRPTR^.ICAFE);
                  counter :=8;
                END;
               END;
              END
             ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 8;
               END;
             END;



           8 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,14);
              R:= READKEY;
              IF(R =CHR(32)) THEN
                 BEGIN
                 WRITE('  ');
                 CURRPTR^.FOUCST:=('     ');
                 GOTOXY(25,14);
                 CTR := 12;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,14);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,14);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.FOUCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,14);
                          WRITE(CURRPTR^.FOUCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,14);
                       WRITE('      ');
                       GOTOXY(25,14);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.FOUCST := '     '
                    ELSE
                    IF (CURRPTR^.FOUCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.FOUCST[1]:= CURRPTR^.FOUCST[COUNTER];
                       CURRPTR^.FOUCST[COUNTER]:= ' ';
                       CURRPTR^.FOUCST := ' ';
                       GOTOXY(25,14);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.FOUCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[1];
    {1 DIGITS}         CURRPTR^.FOUCST[1]:= ' ';
                       GOTOXY(25,14);
                       WRITE('    .',CURRPTR^.FOUCST[5])
                       END
                    ELSE IF (CURRPTR^.FOUCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[2];
    {2 DIGITS}         CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       CURRPTR^.FOUCST[2]:= ' ';
                       GOTOXY(25,14);
                       WRITE('   .',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE IF (CURRPTR^.FOUCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[3];
                       CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[2];
    {3 DIGITS}         CURRPTR^.FOUCST[3]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       CURRPTR^.FOUCST[2]:= ' ';
                       GOTOXY(25,14);
                       WRITE('  ',CURRPTR^.FOUCST[3],'.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE IF (CURRPTR^.FOUCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[4];
    {4 DIGITS}         CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[3];
                       CURRPTR^.FOUCST[3]:= CURRPTR^.FOUCST[2];
                       CURRPTR^.FOUCST[2]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       GOTOXY(25,14);
                       WRITE(' ',CURRPTR^.FOUCST[2],CURRPTR^.FOUCST[3],'.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,14);
                       WRITE(CURRPTR^.FOUCST[1],CURRPTR^.FOUCST[2],CURRPTR^.FOUCST[3]);
                       WRITE('.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END;
                   GOTOXY(62,14);
                   write('');
                   GOTOXY(62,14);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CTR:=9;
                  CURRPTR^.FCAFE := R;
                  GOTOXY(62,14);
                  WRITE(CURRPTR^.FCAFE);
                  counter := 8;
                END;
               END;
              END
             ELSE
               BEGIN
               OT:= CHR(9);
               CTR:= 9;
               END;
             END;



         9: BEGIN
           OT := CHR(27);
           gotoxy(17,23);
           IF (MORETOSEARCH = TRUE) THEN
           RCODE := '3'
           ELSE
           BEGIN
           TEXTBACKGROUND(7);
           TEXTCOLOR(BLACK);
           write('PRESS  E  TO EDIT ANOTHER OR  R  TO RETURN TO MENU');
           TEXTBACKGROUND(BLACK);
           TEXTCOLOR(15);
           GOTOXY(39,24);
           TEXTCOLOR(14);
           WRITE('');
           GOTOXY(39,24);
           RCODE := READKEY;
           CLRSCR;
           END;
          END;
         END;
       END;
     END;
  UNTIL RCODE IN REP
END;






procedure Insertsort(var head,tempptr : recptr);

 var
  p,q : recptr;
  found : boolean;

begin
  found := false;
  p := head;
  q := head;
  while (p<> NIL) and (NOT FOUND) do
  begin
    if (p^.empcode[1] < tempptr^.empcode[1]) or ((p^.empcode[1] = tempptr^.empcode[1]) and
       (p^.empcode[2] < tempptr^.empcode[2]))
     or((p^.empcode[1] = tempptr^.empcode[1]) and (p^.empcode[2] = tempptr^.empcode[2]) and
       (p^.empcode[3] < tempptr^.empcode[3]))
     or((p^.empcode[1] = tempptr^.empcode[1]) and (p^.empcode[2] = tempptr^.empcode[2]) and
       (p^.empcode[3] = tempptr^.empcode[3]) and (p^.empcode[4] < tempptr^.empcode[4]))
     or((p^.empcode[1] = tempptr^.empcode[1]) and (p^.empcode[2] = tempptr^.empcode[2]) and
       (p^.empcode[3] = tempptr^.empcode[3]) and (p^.empcode[4] = tempptr^.empcode[4]) and
       (p^.empcode[5] < tempptr^.empcode[5]))
     or((p^.empcode[1] = tempptr^.empcode[1]) and (p^.empcode[2] = tempptr^.empcode[2]) and
       (p^.empcode[3] = tempptr^.empcode[3]) and (p^.empcode[4] = tempptr^.empcode[4]) and
       (p^.empcode[5] = tempptr^.empcode[5]) and (p^.empcode[6] < tempptr^.empcode[6]))
    THEN
    BEGIN
      q:= p;
      p := p^.next
    END
    ELSE
      found := true
  END;
  tempptr^.next := p;
  if (p<>q) then
   q^.next := tempptr
  else
   head := tempptr
  end;





PROCEDURE init(var listhead,listtail : recptr; var proceed : char);
 begin
  listhead := nil;                         {initialize list}
  listtail := nil;
 end;



procedure delemp(var current : recptr);

var
 location, ptrto : recptr;
 found : boolean;

begin
 location := listhead;
 found := false;
 ptrto := listhead;

 while (location <> NIL) and (not found) do
 begin
   if (location = nil) and not found then     {not working}
   begin
    write('NOT IN LIST');
    delay(4000);
   end;
   if (coded = location^.empcode) then
   begin
       if listhead = location then
       begin
         found := true;
         listhead := listhead^.next;
         dispose(location);
       end
       else
       begin
         found := true;
         ptrto^.next := location^.next;
         dispose(location);
       end
      end
   else
   begin
     ptrto := location;
     location := location^.next;
   end;
 end;
end;

procedure delemp1;

var
 current :recptr;

begin
  delemp(current);
end;


Procedure inputnew(var current : recptr);


var
 ot  : char;
 ctr : integer;
 tempc,r   : char;
 counter,counter2, mover : integer;
 location : recptr;
 found : boolean;
 node : recptr;
 notvalid : boolean;

begin
 ctr := 1;
 found := false;
 location := listhead;
 repeat

   while not (location = nil)  do
   begin
     if (location^.empcode = coded) then found:= true;
     if found then
    begin
      gotoxy(2,2);
      write('                            ');
      textcolor(26);
      gotoxy(2,2);
      write('CODE ALREADY EXISTS TRY AGAIN');
      delay(2000);
      gotoxy(2,2);
      textcolor(15);
      write('                              ');
      getcode;
      location := listhead;
      found := false;
    end
     else location := location^.next;
   end;
 until not found;

 counter2 := 1;
 gotoxy(14,6);
 ot := chr(9);
 new(node);
 node^.empcode := coded;
 insertsort(listhead,node);
 gotoxy(14,4);
 write(node^.empcode);
 node^.lastname:=('                    ');
 node^.firstname:=('          ');
 node^.bcom1:=('                                                   ');
 node^.bcom2:=('                                                   ');
 node^.bcom3:=('                                                   ');
 node^.medcst:=('00000');
 node^.dencst:=('00000');
 node^.cancst:=('00000');
 node^.discst:=('00000');
 node^.lifcst:=('00000');
 node^.hoscst:=('00000');
 node^.intcst:=('00000');
 node^.foucst:=('00000');
 node^.mcafe :=('N');
 node^.dcafe :=('N');
 node^.ccafe :=('N');
 node^.dicafe :=('N');
 node^.lcafe :=('N');
 node^.hcafe :=('N');
 node^.icafe :=('N');
 node^.fcafe :=('N');
 gotoxy(2,3);
 write('ENTER THE LAST NAME ');
  while( counter2 <21) do
 begin
   r:= readkey;
   if (r= chr(13)) then counter2 := 21;
   if(r>chr(64)) and (r < chr(123)) then
   begin
     node^.lastname[counter2] := r;
     gotoxy(21+counter2,3);
     if ((node^.lastname[1]) > chr(96)) then
     node^.lastname[1] := chr((ord(node^.lastname[1]) -32));
     write(node^.lastname[counter2]);
     counter2:= counter2 +1;
   end
   else
   if (r>chr(122)) or (r < chr(65)) and not (r= chr(13)) and (r <> chr(8)) then
   begin
    sound(1150);
    delay(400);
    nosound;
   end;
   if(r =chr(8)) and (counter2 > 1) and (counter2<21) then
   begin
    node^.lastname[counter2-1] := ' ';
    gotoxy((22+counter2)-2,3);
    write(' ');
    gotoxy((22+counter2)-2,3);
    counter2 := counter2-1;
  end;
 end;
 gotoxy(22,3);
 counter2 := 1;
 write('                                           ');
 gotoxy(2,3);
 write('ENTER THE FIRST NAME ');
 while( counter2 <11) do
 begin
   r:= readkey;
   if (r= chr(13)) then counter2 := 11;
   if(r>chr(64)) and (r < chr(123))and (counter2 <11) then
   begin
     node^.firstname[counter2] := r;
     gotoxy(22+counter2,3);
     if ((node^.firstname[1]) > chr(96)) then
     node^.firstname[1] := chr((ord(node^.firstname[1]) -32));
     write(node^.firstname[counter2]);
     counter2:= counter2 +1;
   end
   else
   if (r>chr(122)) or (r < chr(65)) and not (r= chr(13)) and (r <> chr(8)) then
   begin
    sound(1150);
    delay(400);
    nosound;
   end;
   if(r =chr(8)) and (counter2 > 1) and (counter2<11) then
   begin
    node^.firstname[counter2-1] := ' ';
    gotoxy((23+counter2)-2,3);
    write(' ');
    gotoxy((23+counter2)-2,3);
    counter2 := counter2-1;
  end;
 end;
 counter2 :=1;
 gotoxy(2,3);
 write('                                           ');
 gotoxy(14,5);
  while ((counter2 <11) and not (node^.firstname[counter2] = ' ')) do
 begin
   write(node^.firstname[counter2]);
   counter2 := counter2 +1;
 end;
 write(' ');
 counter2 := 1;
 while not (node^.lastname[counter2] = ' ') do
 begin
   write(node^.lastname[counter2]);
   counter2 := counter2 +1;
 end;
 while (ot <> chr(27)) do          {allows alpha chars in numeric fields}
 begin                                           {   :(    }

  case ctr of

  1: begin
       mover := 1;
       counter :=1;
       gotoxy(14,6);
       write('         ');
       gotoxy(14,6);
       write('');
       ctr := 2;
       gotoxy(14,6);
       node^.dob :='000000';
       while counter <8 do
        begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((14+counter)-2,6);
             write('');
             gotoxy((14+counter)-2,6);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(14,6);
             counter := counter +1;
             write(node^.dob[1],node^.dob[2],'-',node^.dob[3],node^.dob[4],'-',
             node^.dob[5],node^.dob[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  node^.dob[counter] := R;
                  gotoxy(13+counter,6);
                  write(node^.dob[counter]);
                  counter := counter +1;
               end;
             end;
        end;
    end;

   2: begin
       counter :=1;
       gotoxy(14,7);
       ctr := 3;
       node^.street :='                    ';
       write('');
       gotoxy(14,7);
       while (counter < 21) do
         begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((14+counter)-2,7);
             write('');
             gotoxy((14+counter)-2,7);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.street[counter] := r;
              gotoxy(13 + counter,7);
              write(node^.street[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(13+counter,7);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
         end;
      end;


   3: begin
       counter :=1;
       gotoxy(14,8);
       ctr := 4;
       node^.city :='                    ';
       write('');
       gotoxy(14,8);
       while (counter < 21) do
       begin
            notvalid := false;
            r := readkey;
            if (r< chr(65)) or (r > chr(122)) then
            begin
              if (r <> chr(13)) and (r <> chr(8)) then
              begin
                sound(1150);
                delay(400);
                notvalid := true;
                nosound;
              end;
            end;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if ((r=chr(8)) and (counter <21) and (counter>1))  then
            begin
             gotoxy((14+counter)-2,8);
             write('');
             gotoxy((14+counter)-2,8);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) and not (notvalid) then
            begin
              node^.city[counter] := r;
              gotoxy(13 + counter,8);
              write(node^.city[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(13+counter,8);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end;


   4: begin
       counter :=1;
       gotoxy(14,9);
       ctr := 5;
       node^.state :='  ';
       write('');
       gotoxy(14,9);
       while (counter < 4) do
        begin
            r := readkey;
            if (r=chr(8)) and (counter <4) and (counter>1) then
            begin
             gotoxy((14+counter)-2,9);
             write('');
             gotoxy((14+counter)-2,9);
             counter := counter -1;
            end;
            if (counter > 2) and (r=chr(13)) then
            begin     
                gotoxy(14,9);
                counter := counter +1;
                write(node^.state[1],node^.state[2]);
              end;
            if (r>chr(122)) or (r <chr(65)) and not (r = chr(13)) and (r <> chr(8)) then
            begin
              sound(1150);
              delay(400);
              nosound;
            end
            else
            if (r > chr(64)) and (r < chr(123)) then
            begin
               if (counter < 3) then
               begin
                 if (r>chr(97)) or (r < chr(123)) then
                 r:= chr((ord(r)-32));
                 node^.state[counter] := r;
                 gotoxy(13 + counter,9);
                 write(node^.state[counter]);
                 counter := counter +1;
               end;
            end;
        end;

   end;

   5: begin
       counter :=1;
       gotoxy(14,10);
       ctr := 6;
       node^.zipcode :='00000';
       write('');
       gotoxy(14,10);
       while counter < 7 do
        begin
            r := readkey;
             if (r=chr(8)) and (counter <7) and (counter>1) then
             begin
               gotoxy((14+counter)-2,10);
               write('');
               gotoxy((14+counter)-2,10);
               counter := counter -1;
             end;
             if (r> chr(57)) or (r < chr(48)) and not (r= chr(13)) and (r<> chr(8)) then
             begin
               sound(1150);
               delay(400);
               nosound;
             end
             else
             if (r> chr(47)) and (r< chr(58)) then
             begin
               if (counter < 6) then
               begin
                 node^.zipcode[counter] := R;
                 gotoxy(13 + counter,10);
                 write(node^.zipcode[counter]);
                 counter := counter +1;
               end;
            end;
            if (counter = 6) and (r= chr(13)) then counter:= counter +1;
          end;
    end;



   6: begin
       mover := 1;
       counter :=1;
       gotoxy(14,11);
       ctr := 7;
       node^.ssnum :='000000000';
       write('           ');
       gotoxy(14,11);
       write('');
       gotoxy(14,11);
       while counter <11 do
       begin
           r := readkey;
           if (r=chr(8)) and (counter <11) and (counter>1) then
           begin
             gotoxy((14+counter)-2,11);
             write('');
             gotoxy((14+counter)-2,11);
             counter := counter -1;
            end;
           if ((counter > 9) and (r = chr(13))) then
           begin
             gotoxy(14,11);
             counter := counter +1;
             write(node^.ssnum[1],node^.ssnum[2],node^.ssnum[3],'-',node^.ssnum[4],
             node^.ssnum[5],'-',node^.ssnum[6],node^.ssnum[7],node^.ssnum[7],node^.ssnum[9]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<10) then
               begin
                  node^.ssnum[counter] := R;
                  gotoxy(13+counter,11);
                  write(node^.ssnum[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end;

   7: begin
       mover := 1;
       counter :=1;
       gotoxy(52,4);
       ctr := 8;
       node^.homephone :='0000000000';
       write('          ');
       gotoxy(52,4);
       write('              ');
       gotoxy(52,4);
       write('');
       gotoxy(52,4);
       while counter <12 do
       begin
           r := readkey;
           if (r=chr(8)) and (counter <12) and (counter>1) then
           begin
             gotoxy((52+counter)-2,4);
             write('');
             gotoxy((52+counter)-2,4);
             counter := counter -1;
            end;
           if ((counter > 10) and (r = chr(13))) then
           begin
             gotoxy(52,4);
             counter := counter +1;
             write('(',node^.homephone[1],node^.homephone[2],node^.homephone[3],')-',node^.homephone[4],
             node^.homephone[5],node^.homephone[6],'-',node^.homephone[7],node^.homephone[7],
             node^.homephone[9],
             node^.homephone[10],node^.homephone[10]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<11) then
               begin
                  node^.homephone[counter] := R;
                  gotoxy(51+counter,4);
                  write(node^.homephone[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end;


    8: begin
       mover := 1;
       counter :=1;
       gotoxy(52,5);
       ctr := 9;
       node^.emphone :='0000000000';
       write('          ');
       gotoxy(52,5);
       write('              ');
       gotoxy(52,5);
       write('');
       gotoxy(52,5);
       while counter <12 do
       begin
           r := readkey;
           if (r=chr(8)) and (counter <12) and (counter>1) then
           begin
             gotoxy((52+counter)-2,5);
             write('');
             gotoxy((52+counter)-2,5);
             counter := counter -1;
            end;
           if ((counter > 10) and (r = chr(13))) then
           begin
             gotoxy(52,5);
             counter := counter +1;
             write('(',node^.emphone[1],node^.emphone[2],node^.emphone[3],')-',node^.emphone[4],
             node^.emphone[5],node^.emphone[6],'-',node^.emphone[7],node^.emphone[7],node^.emphone[9],
             node^.emphone[10],node^.emphone[10]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<11) then
               begin
                  node^.emphone[counter] := R;
                  gotoxy(51+counter,5);
                  write(node^.emphone[counter]);
                  counter := counter +1;
               end;
           end;
        end;
    end;
 
   9: begin
       mover := 1;
       counter :=1;
       gotoxy(52,6);
       write('        ');
       gotoxy(52,6);
       write('');
       ctr := 10;
       gotoxy(52,6);
       node^.hiredate :='000000';
       while counter <8 do
       begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,6);
             write('');
             gotoxy((52+counter)-2,6);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,6);
             counter := counter +1;
             write(node^.hiredate[1],node^.hiredate[2],'-',node^.hiredate[3],node^.hiredate[4],'-',
             node^.hiredate[5],node^.hiredate[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  node^.hiredate[counter] := R;
                  gotoxy(51+counter,6);
                  write(node^.hiredate[counter]);
                  counter := counter +1;
               end;
           end;
        end;
    end;


   10: begin
       counter :=1;
       gotoxy(52,7);
       ctr := 11;
       node^.licnum :='                    ';
       write('');
       gotoxy(52,7);
       while (counter < 21) do
       begin
          r := readkey;
          if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((52+counter)-2,7);
             write('');
             gotoxy((52+counter)-2,7);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.licnum[counter] := r;
              gotoxy(51 + counter,7);
              write(node^.licnum[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(51+counter,7);
              while (counter <21) do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
      end;


   11: begin
       mover := 1;
       counter :=1;
       gotoxy(52,8);
       write('        ');
       gotoxy(52,8);
       write('');
       ctr := 12;                  {19 ends loop}
       gotoxy(52,8);
       node^.licexp :='000000';
       while counter <8 do
       begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,8);
             write('');
             gotoxy((52+counter)-2,8);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,8);
             counter := counter +1;
             write(node^.licexp[1],node^.licexp[2],'-',node^.licexp[3],node^.licexp[4],'-',
             node^.licexp[5],node^.licexp[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  node^.licexp[counter] := R;
                  gotoxy(51+counter,8);
                  write(node^.licexp[counter]);
                  counter := counter +1;
               end;
             end;
           end;
      end;


   12: begin
       mover := 1;
       counter :=1;
       gotoxy(52,9);
        write('        ');
         gotoxy(52,9);
         write('');
         ctr := 13;
         gotoxy(52,9);
         node^.phexpires :='000000';
         while counter <8 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,9);
             write('');
             gotoxy((52+counter)-2,9);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,9);
             counter := counter +1;
             write(node^.phexpires[1],node^.phexpires[2],'-',node^.phexpires[3],node^.phexpires[4],'-',
             node^.phexpires[5],node^.phexpires[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  node^.phexpires[counter] := R;
                  gotoxy(51+counter,9);
                  write(node^.phexpires[counter]);
                  counter := counter +1;
               end;
             end;
           end;
      end;

   13: begin
       mover := 1;
       counter :=1;
       gotoxy(52,10);
        write('   ');
         gotoxy(52,10);
         write('');
         ctr := 14;                  {19 ends loop}
         gotoxy(52,10);
         node^.rehire :='   ';
         gotoxy(52,10);
         while  not ((node^.rehire ='YES') or (node^.rehire ='NO ')) do
         begin
           r := readkey;
           if (r='y') or (r='Y') then
            node^.rehire:='YES'
           else if (r='n') or (r='N') then
            node^.rehire:='NO '
           else
           begin
             sound(1150);
             delay(400);
             nosound;
           end;
         end;
        gotoxy(52,10);
        write(node^.rehire);
        gotoxy(52,11);
   
   end;

  14: begin
       counter :=1;
       gotoxy(52,11);
         ctr := 15;
          node^.emcontact :='                    ';
          write('');
          gotoxy(52,11);
          while (counter < 21) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((52+counter)-2,11);
             write('');
             gotoxy((52+counter)-2,11);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.emcontact[counter] := r;
              gotoxy(51 + counter,11);
              write(node^.emcontact[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(51+counter,11);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
       end;


   15: begin
       counter :=1;
       gotoxy(9,19);
             ctr := 16;
          node^.comm1 :='                                                            ';
          write('');
          gotoxy(9,19);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,19);
             write('');
             gotoxy((9+counter)-2,19);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.comm1[counter] := r;
              gotoxy(8 + counter,19);
              write(node^.comm1[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,19);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
   
      end;

    16: begin
       counter :=1;
       gotoxy(9,20);
       ctr := 17;
          node^.comm2 :='                                                            ';
          write('');
          gotoxy(9,20);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,20);
             write('');
             gotoxy((9+counter)-2,20);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.comm2[counter] := r;
              gotoxy(8 + counter,20);
              write(node^.comm2[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,20);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;


      end;


      17: begin
       counter :=1;
       gotoxy(9,21);
          ctr := 19;
          node^.comm3 :='                                                            ';
          write('');
          gotoxy(9,21);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,21);
             write('');
             gotoxy((9+counter)-2,21);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              node^.comm3[counter] := r;
              gotoxy(8 + counter,21);
              write(node^.comm3[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,21);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
      end;


    19: begin
        gotoxy(29,12);
        write('SAVE Y/N ?');
        R := readkey;
        if (r = 'N') or (r = 'n') then
        begin
         gotoxy(29,12);
         write('           ');
         ctr :=1;
        end
        else
         if (r='Y') or (r='y') then
        begin
         ot:= chr(27)
        end
        else
        if not ((r='n') or (r='N') or (r='Y') or (r='y')) then
        begin
          sound(1150);
          delay(400);
          nosound;
        end
       end;

  end;                         {case}

  end
end;
procedure getnew;

var current: recptr;

begin
  inputnew(current);
end;




Procedure tabmodify(var current:recptr);

var
 ot  : char;
 ctr : integer;
 r   : char;
 counter, mover : integer;

begin
 ctr := 1;
 gotoxy(14,6);                        {************ HELP ***********}
 ot := chr(9);                      {array index not valid error chkng}
 while (ot <> chr(27)) do          {allows alpha chars in numeric fields}
 begin                                           {   :(    }

  case ctr of

  1: begin
       mover := 1;
       counter :=1;
       gotoxy(14,6);
       r :=readkey;
       if (r = chr(32)) then
       begin
         write('        ');
         gotoxy(14,6);
         write('');
         ctr := 2;
         gotoxy(14,6);
         current^.dob :='000000';
         while counter <8 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((14+counter)-2,6);
             write('');
             gotoxy((14+counter)-2,6);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(14,6);
             counter := counter +1;
             write(current^.dob[1],current^.dob[2],'-',current^.dob[3],current^.dob[4],'-',current^.dob[5],current^.dob[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  current^.dob[counter] := R;
                  gotoxy(13+counter,6);
                  write(current^.dob[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 2;
       end;
    end;

   2: begin
       counter :=1;
       gotoxy(14,7);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 3;
          current^.street :='                    ';
          write('');
          gotoxy(14,7);
          while (counter < 21) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((14+counter)-2,7);
             write('');
             gotoxy((14+counter)-2,7);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.street[counter] := r;
              gotoxy(13 + counter,7);
              write(current^.street[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(13+counter,7);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=3;
        end;
      end;


   3: begin
       counter :=1;
       gotoxy(14,8);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 4;
          current^.city :='                    ';
          write('');
          gotoxy(14,8);
          while (counter < 21) do
          begin
            r := readkey;
            if (r< chr(65)) or (r > chr(122)) then
            begin
              if (r <> chr(13)) and (r <> chr(8)) then
              begin
                sound(1150);
                delay(400);
                nosound;
              end;
            end;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if ((r=chr(8)) and (counter <21) and (counter>1))  then
            begin
             gotoxy((14+counter)-2,8);
             write('');
             gotoxy((14+counter)-2,8);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.city[counter] := r;
              gotoxy(13 + counter,8);
              write(current^.city[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(13+counter,8);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=4;
        end;
      end;


   4: begin
       counter :=1;
       gotoxy(14,9);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 5;
          current^.state :='  ';
          write('');
          gotoxy(14,9);
          while (counter < 4) do
          begin
            r := readkey;
            if (r=chr(8)) and (counter <4) and (counter>1) then
            begin
             gotoxy((14+counter)-2,9);
             write('');
             gotoxy((14+counter)-2,9);
             counter := counter -1;
            end;
            if (counter > 2) and (r=chr(13)) then
            begin     
                gotoxy(14,9);
                counter := counter +1;
                write(current^.state[1],current^.state[2]);
              end;
            if (r>chr(122)) or (r <chr(65)) and not (r = chr(13)) and (r <> chr(8)) then
            begin
              sound(1150);
              delay(400);
              nosound;
            end
            else
            if (r > chr(64)) and (r < chr(123)) then
             begin
               if (counter < 3) then
               begin
               if (r>chr(97)) or (r < chr(123)) then
                 r:= chr((ord(r)-32));
                current^.state[counter] := r;
                gotoxy(13 + counter,9);
                write(current^.state[counter]);
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=5;
        end;
      end;

   5: begin
       counter :=1;
       gotoxy(14,10);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 6;
          current^.zipcode :='00000';
          write('');
          gotoxy(14,10);
          while counter < 7 do
            begin
             r := readkey;
             if (r=chr(8)) and (counter <7) and (counter>1) then
             begin
               gotoxy((14+counter)-2,10);
               write('');
               gotoxy((14+counter)-2,10);
               counter := counter -1;
             end;
             if (r> chr(57)) or (r < chr(48)) and not (r= chr(13)) and (r<> chr(8)) then
             begin
               sound(1150);
               delay(400);
               nosound;
             end
             else
             if (r> chr(47)) and (r< chr(58)) then
             begin
               if (counter < 6) then
               begin
                 current^.zipcode[counter] := R;
                 gotoxy(13 + counter,10);
                 write(current^.zipcode[counter]);
                 counter := counter +1;
               end;
              end;
             if (counter = 6) and (r= chr(13)) then counter:= counter +1;
            end;
           end
        else
        begin
          ot := chr(9);
          ctr :=6;
        end;
      end;

   6: begin
       mover := 1;
       counter :=1;
       gotoxy(14,11);
       r :=readkey;
       if (r = chr(32)) then
       begin
         ctr := 7;
         current^.ssnum :='000000000';
         write('           ');
         gotoxy(14,11);
         write('');
         gotoxy(14,11);
         while counter <11 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <11) and (counter>1) then
           begin
             gotoxy((14+counter)-2,11);
             write('');
             gotoxy((14+counter)-2,11);
             counter := counter -1;
            end;
           if ((counter > 9) and (r = chr(13))) then
           begin
             gotoxy(14,11);
             counter := counter +1;
             write(current^.ssnum[1],current^.ssnum[2],current^.ssnum[3],'-',current^.ssnum[4],
             current^.ssnum[5],'-',current^.ssnum[6],current^.ssnum[7],current^.ssnum[7],current^.ssnum[9]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<10) then
               begin
                  current^.ssnum[counter] := R;
                  gotoxy(13+counter,11);
                  write(current^.ssnum[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 7;
       end;
    end;



     7: begin
       mover := 1;
       counter :=1;
       gotoxy(52,4);
       r :=readkey;
       if (r = chr(32)) then
       begin
         ctr := 8;
         current^.homephone :='0000000000';
         write('          ');
         gotoxy(52,4);
         write('                    ');
         gotoxy(52,4);
         write('');
         gotoxy(52,4);
         while counter <12 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <12) and (counter>1) then
           begin
             gotoxy((52+counter)-2,4);
             write('');
             gotoxy((52+counter)-2,4);
             counter := counter -1;
            end;
           if ((counter > 10) and (r = chr(13))) then
           begin
             gotoxy(52,4);
             counter := counter +1;
             write('(',current^.homephone[1],current^.homephone[2],current^.homephone[3],')-',current^.homephone[4],
             current^.homephone[5],current^.homephone[6],'-',current^.homephone[7],current^.homephone[7],current^.homephone[9],
             current^.homephone[10],current^.homephone[10]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<11) then
               begin
                  current^.homephone[counter] := R;
                  gotoxy(51+counter,4);
                  write(current^.homephone[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 8;
       end;
    end;

   
    8: begin
       mover := 1;
       counter :=1;
       gotoxy(52,5);
       r :=readkey;
       if (r = chr(32)) then
       begin
         ctr := 9;
         current^.emphone :='0000000000';
         write('                        ');
         gotoxy(52,5);
         write('                             ');
         gotoxy(52,5);
         write('');
         gotoxy(52,5);
         while counter <12 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <12) and (counter>1) then
           begin
             gotoxy((52+counter)-2,5);
             write('');
             gotoxy((52+counter)-2,5);
             counter := counter -1;
            end;
           if ((counter > 10) and (r = chr(13))) then
           begin
             gotoxy(52,5);
             counter := counter +1;
             write('(',current^.emphone[1],current^.emphone[2],current^.emphone[3],')-',current^.emphone[4],
             current^.emphone[5],current^.emphone[6],'-',current^.emphone[7],current^.emphone[7],current^.emphone[9],
             current^.emphone[10],current^.emphone[10]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<11) then
               begin
                  current^.emphone[counter] := R;
                  gotoxy(51+counter,5);
                  write(current^.emphone[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 9;
       end;
    end;
 
     9: begin
       mover := 1;
       counter :=1;
       gotoxy(52,6);
       r :=readkey;
       if (r = chr(32)) then
       begin
         write('        ');
         gotoxy(52,6);
         write('');
         ctr := 10;
         gotoxy(52,6);
         current^.hiredate :='000000';
         while counter <8 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,6);
             write('');
             gotoxy((52+counter)-2,6);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,6);
             counter := counter +1;
             write(current^.hiredate[1],current^.hiredate[2],'-',current^.hiredate[3],current^.hiredate[4],'-',
             current^.hiredate[5],current^.hiredate[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  current^.hiredate[counter] := R;
                  gotoxy(51+counter,6);
                  write(current^.hiredate[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 10;
       end;
    end;


    10: begin
       counter :=1;
       gotoxy(52,7);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 11;
          current^.licnum :='                    ';
          write('');
          gotoxy(52,7);
          while (counter < 21) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((52+counter)-2,7);
             write('');
             gotoxy((52+counter)-2,7);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.licnum[counter] := r;
              gotoxy(51 + counter,7);
              write(current^.licnum[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(51+counter,7);
              while (counter <21) do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=11;
        end;
      end;






  
   11: begin
       mover := 1;
       counter :=1;
       gotoxy(52,8);
       r :=readkey;
       if (r = chr(32)) then
       begin
         write('        ');
         gotoxy(52,8);
         write('');
         ctr := 12;                  {19 ends loop}
         gotoxy(52,8);
         current^.licexp :='000000';
         while counter <8 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,8);
             write('');
             gotoxy((52+counter)-2,8);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,8);
             counter := counter +1;
             write(current^.licexp[1],current^.licexp[2],'-',current^.licexp[3],current^.licexp[4],'-',
             current^.licexp[5],current^.licexp[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  current^.licexp[counter] := R;
                  gotoxy(51+counter,8);
                  write(current^.licexp[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 12;
       end;
   end;


   12: begin
       mover := 1;
       counter :=1;
       gotoxy(52,9);
       r :=readkey;
       if (r = chr(32)) then
       begin
         write('        ');
         gotoxy(52,9);
         write('');
         ctr := 13;
         gotoxy(52,9);
         current^.phexpires :='000000';
         while counter <8 do
         begin
           r := readkey;
           if (r=chr(8)) and (counter <8) and (counter>1) then
           begin
             gotoxy((52+counter)-2,9);
             write('');
             gotoxy((52+counter)-2,9);
             counter := counter -1;
            end;
           if ((counter > 6) and (r = chr(13))) then
           begin
             gotoxy(52,9);
             counter := counter +1;
             write(current^.phexpires[1],current^.phexpires[2],'-',current^.phexpires[3],current^.phexpires[4],'-',
             current^.phexpires[5],current^.phexpires[6]);
           end;
           if (r> chr(57)) or (r < chr(48)) and not (r=chr(13)) and (r<>chr(8))
           then
           begin
             sound(1150);
             delay(400);
             nosound;
           end
           else
            if (r < chr(58)) and (r > chr(47)) then
             begin
               if (counter<7) then
               begin
                  current^.phexpires[counter] := R;
                  gotoxy(51+counter,9);
                  write(current^.phexpires[counter]);
                  counter := counter +1;
               end;
             end;
           end;
          end
       else
       begin
         ot := chr(9);
         ctr := 13;
       end;
   end;

   13: begin
       mover := 1;
       counter :=1;
       gotoxy(52,10);
       r :=readkey;
       if (r = chr(32)) then
       begin
         write('   ');
         gotoxy(52,10);
         write('');
         ctr := 14;                  {19 ends loop}
         gotoxy(52,10);
         current^.rehire :='   ';
         gotoxy(52,10);
         while  not ((current^.rehire ='YES') or (current^.rehire ='NO ')) do
         begin
           r := readkey;
           if (r='y') or (r='Y') then
            current^.rehire:='YES'
           else if (r='n') or (r='N') then
            current^.rehire:='NO '
           else
           begin
             sound(1150);
             delay(400);
             nosound;
           end;
         end;
        gotoxy(52,10);
        write(current^.rehire);
        gotoxy(52,11);
        end
       else
       begin
         ot := chr(9);
         ctr := 14;
       end;
   end;

  14: begin
       counter :=1;
       gotoxy(52,11);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 15;
          current^.emcontact :='                    ';
          write('');
          gotoxy(52,11);
          while (counter < 21) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <21) and (counter>1) then
            begin
             gotoxy((52+counter)-2,11);
             write('');
             gotoxy((52+counter)-2,11);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.emcontact[counter] := r;
              gotoxy(51 + counter,11);
              write(current^.emcontact[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(51+counter,11);
              while counter <21 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=15;
        end;
      end;


   15: begin
       counter :=1;
       gotoxy(9,19);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 16;
          current^.comm1 :='                                                            ';
          write('');
          gotoxy(9,19);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,19);
             write('');
             gotoxy((9+counter)-2,19);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.comm1[counter] := r;
              gotoxy(8 + counter,19);
              write(current^.comm1[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,19);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=16;
        end;
      end;

      16: begin
       counter :=1;
       gotoxy(9,20);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 17;
          current^.comm2 :='                                                            ';
          write('');
          gotoxy(9,20);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,20);
             write('');
             gotoxy((9+counter)-2,20);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.comm2[counter] := r;
              gotoxy(8 + counter,20);
              write(current^.comm2[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,20);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=17;
        end;
      end;


      17: begin
       counter :=1;
       gotoxy(9,21);
       r:= readkey;
       if r = chr(32) then
       begin
          ctr := 19;
          current^.comm3 :='                                                            ';
          write('');
          gotoxy(9,21);
          while (counter < 61) do
          begin
            r := readkey;
            if (r > chr(96)) and (r < chr(123)) then
            r:= chr((ord(r)-32));
            if (r=chr(8)) and (counter <61) and (counter>1) then
            begin
             gotoxy((9+counter)-2,21);
             write('');
             gotoxy((9+counter)-2,21);
             counter := counter -1;
            end;
            if (r <> chr(13)) and (r<> chr(8)) then
            begin
              current^.comm3[counter] := r;
              gotoxy(8 + counter,21);
              write(current^.comm3[counter]);
              counter := counter +1;
            end;
            if (r = chr(13)) then
            begin
              gotoxy(8+counter,21);
              while counter <61 do
              begin
                write(' ');
                counter := counter +1;
              end;
            end;
          end;
         end
        else
        begin
          ot := chr(9);
          ctr :=19;
        end;
      end;


    19: begin
        gotoxy(29,12);
        write('CONTINUE ?');
        R := readkey;
        if (r = 'Y') or (r = 'y') then
        begin
         gotoxy(29,12);
         write('           ');
         ctr :=1;
        end
        else
         if (r='N') or (r='n') then
        begin
         ot:= chr(27)
        end
        else
        if not ((r='n') or (r='N') or (r='Y') or (r='y')) then
        begin
          sound(1150);
          delay(400);
          nosound;
        end
       end;

  end;                         {case}

  end
end;


Procedure getnewemp;

var
current : recptr;

begin
 drprscr;
 drawcombox;
 inputnew(current);
end;



PROCEDURE addnode(var listhead, listtail : recptr);

 begin                                       {add first node}
  if listhead = nil
   then begin
         new(listhead);
         read(sfile,listhead^.empcode);
         read(sfile,listhead^.firstname);
         read(sfile,listhead^.lastname);
         read(sfile,listhead^.ssnum);
         read(sfile,listhead^.street);
         read(sfile,listhead^.city);
         read(sfile,listhead^.state);
         read(sfile,listhead^.zipcode);
         read(sfile,listhead^.dob);
         read(sfile,listhead^.homephone);
         read(sfile,listhead^.emphone);
         read(sfile,listhead^.hiredate);
         read(sfile,listhead^.emcontact);
         read(sfile,listhead^.licnum);
         read(sfile,listhead^.licexp);
         read(sfile,listhead^.phexpires);
         read(sfile,listhead^.rehire);
         read(sfile,listhead^.comm1);
         read(sfile,listhead^.comm2);
         read(sfile,listhead^.comm3);
         read(sfile,listhead^.medcst);
         read(sfile,listhead^.mcafe);
         read(sfile,listhead^.dencst);
         read(sfile,listhead^.dcafe);
         read(sfile,listhead^.cancst);
         read(sfile,listhead^.ccafe);
         read(sfile,listhead^.discst);
         read(sfile,listhead^.dicafe);
         read(sfile,listhead^.lifcst);
         read(sfile,listhead^.lcafe);
         read(sfile,listhead^.hoscst);
         read(sfile,listhead^.hcafe);
         read(sfile,listhead^.intcst);
         read(sfile,listhead^.icafe);
         read(sfile,listhead^.foucst);
         read(sfile,listhead^.fcafe);
         read(sfile,listhead^.bcom1);
         read(sfile,listhead^.bcom2);
         readln(sfile,listhead^.bcom3);
         listhead^.next := NIL;
         listtail := listhead;
       end
   else begin                                  {add NON beginning nodes}
         new(listtail^.next);
         if listhead = listtail
           then listhead^.next := listtail^.next;
         listtail := listtail^.next;
         read(sfile,listtail^.empcode);
         read(sfile,listtail^.firstname);
         read(sfile,listtail^.lastname);
         read(sfile,listtail^.ssnum);
         read(sfile,listtail^.street);
         read(sfile,listtail^.city);
         read(sfile,listtail^.state);        {          ENABLED        }
         read(sfile,listtail^.zipcode);      { *********************** }
         read(sfile,listtail^.dob);
         read(sfile,listtail^.homephone);
         read(sfile,listtail^.emphone);
         read(sfile,listtail^.hiredate);
         read(sfile,listtail^.emcontact);
         read(sfile,listtail^.licnum);
         read(sfile,listtail^.licexp);
         read(sfile,listtail^.phexpires);
         read(sfile,listtail^.rehire);
         read(sfile,listtail^.comm1);
         read(sfile,listtail^.comm2);
         read(sfile,listtail^.comm3);
         read(sfile,listtail^.medcst);
         read(sfile,listtail^.mcafe);
         read(sfile,listtail^.dencst);
         read(sfile,listtail^.dcafe);
         read(sfile,listtail^.cancst);
         read(sfile,listtail^.ccafe);
         read(sfile,listtail^.discst);
         read(sfile,listtail^.dicafe);
         read(sfile,listtail^.lifcst);
         read(sfile,listtail^.lcafe);
         read(sfile,listtail^.hoscst);
         read(sfile,listtail^.hcafe);
         read(sfile,listtail^.intcst);
         read(sfile,listtail^.icafe);
         read(sfile,listtail^.foucst);
         read(sfile,listtail^.fcafe);
         read(sfile,listtail^.bcom1);
         read(sfile,listtail^.bcom2);
         readln(sfile,listtail^.bcom3);
         listtail^.next := nil;
      end
 end;

Procedure getcode;

var
 i,ct: integer;
 temp : string[6];
 achar : char;
 lowercased, uppercased, badchar : boolean;

begin
  coded := '      ';
  i :=1;
  textcolor(13);
  textbackground(black);
  gotoxy(2,2);
  write('ENTER EMPLOYEE CODE: ');
  gotoxy(24,2);
  while i <7 do
  begin
  uppercased := false;
  lowercased := false;
  badchar := true;
  achar := readkey;
  if achar = chr(13) then
   begin
     for i := i to 6 do
     coded[i] := ' ';
     if i = 6 then i:= 7
   end;
  if achar = chr(8) then
  begin
   if i = 1 then
    begin
     gotoxy(24,2);
     write(' ');
     gotoxy(24,2);
    end
   else
   begin
    i := i-1;
    gotoxy(23+i,2);
    write(' ');
    gotoxy(23+i,2);
   end
   end;

  if (achar < chr(123)) and (achar > chr(96)) then
     lowercased := true


    else if (achar > chr(64)) and (achar < chr(91)) then
     uppercased := true;


    if (lowercased) or (uppercased) then
      badchar := false;

  if lowercased then
    achar := chr((ord(achar)-32));

  if  not badchar then
   begin
     coded[i] := achar;
     write(coded[i]);
     i := i + 1;
   end
   else
     badchar := true
 end;
    gotoxy(2,2);
    write('                             ');
end;

PROCEDURE showlist;

var
 currptr :recptr;
 counter,x : integer;
 moretosearch : boolean;


begin
 currptr := listhead;
 if currptr = NIL then
 begin
  gotoxy(35,2);
  textcolor(28);
  textbackground(black);
  writeln('LIST IS EMPTY');
  textcolor(13);
 end;
 if currptr <> NIL then
    begin
      x:=1;
      drprscr;
      gotoxy(7,30);
      writeln;
      drawcombox;
      gotoxy(14,4);
      textbackground(black);
      textcolor(13);
      moretosearch := true;
      while (moretosearch) and (currptr <> NIL) do
        if (currptr^.empcode <> coded) then
         currptr := currptr^.next
        else
         moretosearch := false;
         if currptr^.next <> NIL
         then
          if currptr^.empcode <> coded then
           currptr := NIL;
      if moretosearch = false then
    begin
      write(currptr^.empcode);
      textcolor(15);
      gotoxy(14,5);
      while (currptr^.lastname[x] > chr(47)) and (x<20) do
      begin
       write(currptr^.lastname[x]);
       x:= x+1;
      end;
      gotoxy(13+x,5);
      write(', ');
      write(currptr^.firstname);
      gotoxy(14,11);
      x:= 1;
      while (x < 10) do
      begin
       if ((x = 4) or (x = 6)) then
        begin
         write('-');
         write(currptr^.ssnum[x]);
         x:= x+1;
        end
        else
        begin
         write(currptr^.ssnum[x]);
         x := x+1;
        end;
      end;
       gotoxy(14,7);
      textcolor(15);
      x:=1;
      while (x <21) and (currptr^.street[x] <> chr(13)) do
      begin
       write(currptr^.street[x]);
       x:=x+1;
       end;
      gotoxy(14,6);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.dob[x]);
        x:= x+1;
      end;
      gotoxy(52,8);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.licexp[x]);
        x:= x+1;
      end;
      gotoxy(52,9);
      textcolor(15);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.phexpires[x]);
        x:= x+1;
      end;
      x:=1;
      textcolor(13);
      gotoxy(14,8);
      while (x <21) and (currptr^.city[x] <> chr(13)) do
      begin
       write(currptr^.city[x]);
       x:=x+1;
       end;
      gotoxy(14,9);
      textcolor(15);
      write(currptr^.state);
      gotoxy(14,10);
      textcolor(13);
      write(currptr^.zipcode);
      gotoxy(52,4);
      textcolor(13);
      x:= 1;
      while (x <11) do
      begin
        if (x = 1) then
          write('(')
        else if (x = 7) then
          write('-')
        else if (x = 4) then
          write(')');
        write(currptr^.homephone[x]);
        x:= x+1;
      end;
      gotoxy(52,5);
      textcolor(15);
      x:= 1;
      while (x <11) do
      begin
        if (x = 1) then
          write('(')
        else if (x = 7) then
          write('-')
        else if (x = 4) then
          write(')');
        write(currptr^.emphone[x]);
        x:= x+1;
      end;
      gotoxy(52,6);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.hiredate[x]);
        x:= x+1;
      end;
      gotoxy(52,11);
      textcolor(15);
      write(currptr^.emcontact);
      gotoxy(52,7);
      textcolor(15);
      write(currptr^.licnum);
      gotoxy(52,10);
      textcolor(13);
      write(currptr^.rehire);
      gotoxy(9,19);
      textcolor(14);
      write(currptr^.comm1);
      gotoxy(9,20);
      write(currptr^.comm2);
      gotoxy(9,21);
      write(currptr^.comm3);
     end
     else
     begin
       clrscr;
       gotoxy(25,12);
       textcolor(11);
       write(' NOT FOUND IN DATABASE');
       gotoxy(25,13);
       write('PRESS RETURN TO CONTINUE');
      end;                         {insert here for expansion of data}
   end;
 currptr := NIL;
 readln;

end;

PROCEDURE modifylist;

var
 currptr :recptr;
 counter,x : integer;
 moretosearch : boolean;


begin
 currptr := listhead;
 if currptr = NIL then
 begin
  gotoxy(35,2);
  textcolor(28);
  textbackground(black);
  writeln('LIST IS EMPTY');
  textcolor(13);
 end;
 if currptr <> NIL then
    begin
      x:=1;
      drprscr;
      gotoxy(7,30);
      writeln;
      drawcombox;
      gotoxy(14,4);
      textbackground(black);
      textcolor(13);
      moretosearch := true;
      while (moretosearch) and (currptr <> NIL) do
        if (currptr^.empcode <> coded) then
         currptr := currptr^.next
        else
         moretosearch := false;
         if currptr^.next <> NIL
         then
          if currptr^.empcode <> coded then
           currptr := NIL;
      if moretosearch <> false then
       writeln('NOT FOUND')
       else
    begin
      write(currptr^.empcode);
      textcolor(15);
      gotoxy(14,5);
      while (currptr^.lastname[x] > chr(47)) and (x<20) do
      begin
       write(currptr^.lastname[x]);
       x:= x+1;
      end;
      gotoxy(13+x,5);
      write(', ');
      write(currptr^.firstname);
      gotoxy(14,11);
      x:= 1;
      while (x < 10) do
      begin
       if ((x = 4) or (x = 6)) then
        begin
         write('-');
         write(currptr^.ssnum[x]);
         x:= x+1;
        end
        else
        begin
         write(currptr^.ssnum[x]);
         x := x+1;
        end;
      end;
       gotoxy(14,7);
      textcolor(15);
      x:=1;
      while (x < 21) and (currptr^.street[x] <> chr(13)) do
      begin
        write(currptr^.street[x]);
        x:=x+1;
      end;
      gotoxy(14,6);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.dob[x]);
        x:= x+1;
      end;
      gotoxy(52,8);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.licexp[x]);
        x:= x+1;
      end;
      gotoxy(52,9);
      textcolor(15);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.phexpires[x]);
        x:= x+1;
      end;
      textcolor(13);
      gotoxy(14,8);
      x:=1;
      while (x <21) and (currptr^.city[x] <> chr(13)) do
      begin
       write(currptr^.city[x]);
       x := x+1;
      end;

      gotoxy(14,9);
      textcolor(15);
      write(currptr^.state);
      gotoxy(14,10);
      textcolor(13);
      write(currptr^.zipcode);
      gotoxy(52,4);
      textcolor(13);
      x:= 1;
      while (x <11) do
      begin
        if (x = 1) then
          write('(')
        else if (x = 7) then
          write('-')
        else if (x = 4) then
          write(')');
        write(currptr^.homephone[x]);
        x:= x+1;
      end;
      gotoxy(52,5);
      textcolor(15);
      x:= 1;
      while (x <11) do
      begin
        if (x = 1) then
          write('(')
        else if (x = 7) then
          write('-')
        else if (x = 4) then
          write(')');
        write(currptr^.emphone[x]);
        x:= x+1;
      end;
      gotoxy(52,6);
      textcolor(13);
      x:= 1;
      while (x <7) do
      begin
        if (x = 3) or (x =5) then
          write('-');
        write(currptr^.hiredate[x]);
        x:= x+1;
      end;
      gotoxy(52,11);
      textcolor(15);
      write(currptr^.emcontact);
      gotoxy(52,7);
      textcolor(15);
      write(currptr^.licnum);
      gotoxy(52,10);
      textcolor(13);
      write(currptr^.rehire);
      gotoxy(9,19);
      textcolor(14);
      write(currptr^.comm1);
      gotoxy(9,20);
      write(currptr^.comm2);
      gotoxy(9,21);
      write(currptr^.comm3);
     end;                            {insert here for expansion of data}
   end;
 tabmodify(currptr);
 clrscr;
end;





PROCEDURE benelist;                  {displays benefits by employee}

var
 currptr :recptr;
 counter,x : integer;
 moretosearch : boolean;
 REP, CONT : SET OF CHAR;
 RCODE : CHAR;


begin
 REPEAT
 CONT := ['V','v'];
 REP := ['R','r'];
 currptr := listhead;
 if currptr = NIL then
     begin
     gotoxy(35,2);
     textcolor(28);
     textbackground(black);
     writeln('LIST IS EMPTY');
     textcolor(13);
     end;
 if currptr <> NIL then
      begin
      x:=1;
      gotoxy(7,30);                  {FORMAT SCREEN}
      writeln;
      gotoxy(14,4);
      textbackground(black);
      textcolor(13);
      moretosearch := true;
      while (moretosearch) and (currptr <> NIL) do
        if (currptr^.empcode <> coded) then
         currptr := currptr^.next
        else
         moretosearch := false;
         if currptr^.next <> NIL
         then
          if currptr^.empcode <> coded then
           currptr := NIL;
      if moretosearch <> false then
       begin
         CLRSCR;
         writeln('NOT FOUND....PRESS A KEY TO CONTINUE');
         readkey;
       end
       else
    begin
      gotoxy(20,3);
      textcolor(15);
      write(currptr^.empcode);
      gotoxy(20,4);
      while (currptr^.lastname[x] > chr(47)) and (x<20) do
      begin
       write(currptr^.lastname[x]);
       x:= x+1;
      end;
      gotoxy(19+x,4);
      write(', ');
      write(currptr^.firstname);
      drawcombox;   {comments box}
      drbrscr;
      textcolor(13);
      gotoxy(25,7);
      write(currptr^.medcst[1],currptr^.medcst[2],currptr^.medcst[3],'.',currptr^.medcst[4],currptr^.medcst[5]);
      gotoxy(62,7);
      write(currptr^.mcafe);
      gotoxy(25,8);
      textcolor(15);
      write(currptr^.dencst[1],currptr^.dencst[2],currptr^.dencst[3],'.',currptr^.dencst[4],currptr^.dencst[5]);
      gotoxy(62,8);
      write(currptr^.dcafe);
      gotoxy(25,9);
      textcolor(13);
      write(currptr^.cancst[1],currptr^.cancst[2],currptr^.cancst[3],'.',currptr^.cancst[4],currptr^.cancst[5]);
      gotoxy(62,9);
      write(currptr^.ccafe);
      gotoxy(25,10);
      textcolor(15);
      write(currptr^.discst[1],currptr^.discst[2],currptr^.discst[3],'.',currptr^.discst[4],currptr^.discst[5]);
      gotoxy(62,10);
      write(currptr^.dicafe);
      gotoxy(25,11);
      textcolor(13);
      write(currptr^.lifcst[1],currptr^.lifcst[2],currptr^.lifcst[3],'.',currptr^.lifcst[4],currptr^.lifcst[5]);
      gotoxy(62,11);
      write(currptr^.lcafe);
      gotoxy(25,12);
      textcolor(15);
      write(currptr^.hoscst[1],currptr^.hoscst[2],currptr^.hoscst[3],'.',currptr^.hoscst[4],currptr^.hoscst[5]);
      gotoxy(62,12);
      write(currptr^.hcafe);
      gotoxy(25,13);
      textcolor(13);
      write(currptr^.intcst[1],currptr^.intcst[2],currptr^.intcst[3],'.',currptr^.intcst[4],currptr^.intcst[5]);
      gotoxy(62,13);
      write(currptr^.icafe);
      gotoxy(25,14);
      textcolor(15);
      write(currptr^.foucst[1],currptr^.foucst[2],currptr^.foucst[3],'.',currptr^.foucst[4],currptr^.foucst[5]);
      gotoxy(62,14);
      write(currptr^.fcafe);
      gotoxy(30,1);
      textcolor(11);
      gotoxy(9,19);
      write(currptr^.bcom1);
      gotoxy(9,20);
      write(currptr^.bcom2);
      gotoxy(9,21);
      write(currptr^.bcom3);
      TEXTBACKGROUND(7);
      textcolor(BLACK);
      gotoxy(17,23);
      write('PRESS  V  TO VIEW ANOTHER OR  R  TO RETURN TO MENU');
      TEXTBACKGROUND(BLACK);
      TEXTCOLOR(15);
      GOTOXY(39,24);
      TEXTCOLOR(14);
      WRITE('');
      GOTOXY(39,24);
      RCODE := READKEY;
    END;
  END;
       IF ((RCODE IN CONT) OR (MORETOSEARCH <> FALSE)) THEN
         BEGIN
         CLRSCR;
         GETCODE;
         DRBRSCR
         END;
       UNTIL RCODE IN REP;
     clrscr;


END;




{benedit origin}

PROCEDURE readdrfile;
 begin
  assign(sfile, 'drivers.msr');
  reset(sfile);
  init(listhead, listtail, proceed);
  while not eof(sfile) do
     begin
      addnode(listhead,listtail);
     end;                                 { makes initial readtextfile llist}
   close(sfile);
 end;

PROCEDURE WRITETOFILE;

var
 current :recptr;

 BEGIN
 current := listhead;
  assign(sfile,'drivers.msr');
  reset(sfile);
  rewrite(sfile);
  while current <> NIL do
   begin
     write(sfile,current^.empcode);
     write(sfile,current^.firstname);
     write(sfile,current^.lastname);
     write(sfile,current^.ssnum);
     write(sfile,current^.street);
     write(sfile,current^.city);
     write(sfile,current^.state);
     write(sfile,current^.zipcode);
     write(sfile,current^.dob);
     write(sfile,current^.homephone);
     write(sfile,current^.emphone);
     write(sfile,current^.hiredate);
     write(sfile,current^.emcontact);
     write(sfile,current^.licnum);
     write(sfile,current^.licexp);
     write(sfile,current^.phexpires);
     write(sfile,current^.rehire);
     write(sfile,current^.comm1);
     write(sfile,current^.comm2);
     write(sfile,current^.comm3);
     write(sfile,current^.medcst);
     write(sfile,current^.mcafe);
     write(sfile,current^.dencst);
     write(sfile,current^.dcafe);
     write(sfile,current^.cancst);
     write(sfile,current^.ccafe);
     write(sfile,current^.discst);
     write(sfile,current^.dicafe);
     write(sfile,current^.lifcst);
     write(sfile,current^.lcafe);
     write(sfile,current^.hoscst);
     write(sfile,current^.hcafe);
     write(sfile,current^.intcst);
     write(sfile,current^.icafe);
     write(sfile,current^.foucst);
     writeln(sfile,current^.fcafe);
     current := current^.next;
   end;
   close(sfile);
end;


end.
