{
Custom Characters 2.3

(C) 1993 Steve Goldsmith
All Rights Reserved

Screen Options dialog.  See CC.PAS for usage.
}

unit OptDlg;

{$I APP.INC}

interface

uses

  Objects, App, Views, Dialogs, Drivers,
  VGA;

type

  ScrOptsData = record {controls data}
    SMode,
    FntTbl1,
    FntTbl2 : integer
  end;

  PScrOptsDlg = ^TScrOptsDlg;
  TScrOptsDlg = object (TDialog)
    ScrMode :PCheckBoxes;
    ChrTable1,
    ChrTable2 : PRadioButtons;
    constructor Init;
  end;

implementation

{TScrOptsDlg}

constructor TScrOptsDlg.Init;

var

  R : TRect;

begin
  R.Assign (0,0,33,14);
  inherited Init (R,'Screen Options');
  R.Assign(2, 2, 31, 5);
  ScrMode := New(PCheckBoxes, Init(R,
    NewSItem('640 X 400',
    NewSItem('Page mode',
    NewSItem('8 colors',
    nil)))));
  Insert(ScrMode);
  R.Assign(1,1,13,2);
  Insert(New(PLabel, Init(R, '~S~creen mode', ScrMode)));
  R.Assign(2, 6, 16, 10);
  ChrTable1 := New(PRadioButtons, Init(R,
    NewSItem('0',
    NewSItem('1',
    NewSItem('2',
    NewSItem('3',
    NewSItem('4',
    NewSItem('5',
    NewSItem('6',
    NewSItem('7',
    nil))))))))));
  Insert(ChrTable1);
  R.Assign(1,5,14,6);
  Insert(New(PLabel, Init(R, 'Font ~1~ table', ChrTable1)));
  R.Assign(17, 6, 31, 10);
  ChrTable2 := New(PRadioButtons, Init(R,
    NewSItem('0',
    NewSItem('1',
    NewSItem('2',
    NewSItem('3',
    NewSItem('4',
    NewSItem('5',
    NewSItem('6',
    NewSItem('7',
    nil))))))))));
  Insert(ChrTable2);
  R.Assign(16,5,29,6);
  Insert(New(PLabel, Init(R, 'Font ~2~ table', ChrTable2)));
  R.Assign(1, 11, 11, 13);
  Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
  R.Assign(14, 11, 24, 13);
  Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)))
end;

end.
