unit prnmenu;

interface


uses printer, crt, getdrfile;

var
  OrigMode,LastCol,LastRow: Word;
  Ch: Char;
  Done: Boolean;

Procedure drawprintall;
Procedure drawprint2all;
Procedure pdall;
Procedure show1;

Implementation

procedure Initialize;
{ Initialize the video mode, LastCol, LastRow }

begin
  CheckBreak:=False;                   { turn off Contrl-C checking }
  OrigMode:=LastMode;                  { Remember original video mode }
  TextMode(CO80);                      { use 43 or 50 lines on EGA/VGA }
  LastCol:=Lo(WindMax)+1;              { get last column, row }
  LastRow:=Hi(WindMax)+1;
end;
  



procedure mwindow(TC,BC : INTEGER);
{ Make a window, with background and foreground colors }
var
  X,Y,Width,Height: Word;

begin
  Width:=(LastCol-2);                      {check screen size}
  Height:=(LastRow-2);
  X:=(0);
  Y:=(0);
  Window(X,Y,X+Width,Y+Height);            {black and white}
  if OrigMode = Mono then
  begin
    TextBackground(White);
    TextColor(Black);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(Black);
    TextColor(White);
  end
  else
  begin
    TextBackground(BC);          {color monitor set purp, black}
    TextColor(TC);
    CLRSCR;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(BC);          {color monitor set purp, black}
    TextColor(TC);
  end; { Init }
end; { MakeWindow }








procedure show1;

var
 fileexists : integer;
 coded: string[6];
 first : recptr;
 gcode : string[6];
 i : integer;
 temp : string[6];
 achar : char;
 lowercased, uppercased, badchar : boolean;
 found : boolean;

begin
  mwindow(13,8);
  coded := '      ';
  i :=1;
  gotoxy(2,2);
  write('ENTER EMPLOYEE CODE: ');
  gotoxy(24,2);
  while i <7 do
  begin
  uppercased := false;
  lowercased := false;
  badchar := true;
  achar := readkey;
  if achar = chr(8) then
     begin
     if i = 1 then
       begin
       gotoxy(24,2);
       write(' ');
       gotoxy(24,2);
       end
    else
      begin
      i := i-1;
      gotoxy(23+i,2);
      write(' ');
      gotoxy(23+i,2);
      end
    end;
  if (achar < chr(123)) and (achar > chr(96)) then
     lowercased := true
  else if (achar > chr(64)) and (achar < chr(91)) then
     uppercased := true;
  if (lowercased) or (uppercased) then
      badchar := false;
  if lowercased then
    achar := chr((ord(achar)-32));
  if  not badchar then
     begin
     coded[i] := achar;
     write(coded[i]);
     i := i + 1;
     end
  else
     badchar := true
  end;
    gotoxy(2,2);
    write('                             ');
    gethead(first);
    while (first <> NIL) and not (found) do
    begin
      if (first^.empcode = coded) then  found:= true
      else first := first^.next
    end;


   {$I-}
   reset(lst);
   {$I+}
   FILEEXISTS:=IORESULT;
   if (ioresult = 0) then
   BEGIN
    mwindow(13,8);
    GOTOXY(20,8);
    WRITE('ͻ');
    GOTOXY(20,9);
    WRITE('                                          ');
    GOTOXY(20,10);
    WRITE('                                          ');
    GOTOXY(20,11);
    WRITE('                                          ');
    GOTOXY(20,12);
    WRITE('                                          ');
    GOTOXY(20,13);
    WRITE('ͼ');
    TEXTCOLOR(15);
    GOTOXY(30,10);
    write('PRINTER NOT FUNCTIONING');
    GOTOXY(29,11);
    WRITE('PRESS ANY KEY TO CONTINUE');
    gotoxy(40,11);
    readkey;
    write('PRINTING');
   write(first^.empcode,'   ',coded, '  ' ,first^.firstname);
   readkey;
  end;
end;

procedure pdall;

var
fileexists :integer;
start : recptr;
movptr : recptr;

begin
  gethead(start);
  clrscr;
  {$I-}
  reset(lst);
  {$I+}
  FILEEXISTS:=IORESULT;
  if (ioresult = 0) then
  BEGIN
    TEXTCOLOR(8);
    TEXTBACKGROUND(15);
    GOTOXY(20,8);
    WRITE('ͻ');
    GOTOXY(20,9);
    WRITE('                                          ');
    GOTOXY(20,10);
    WRITE('                                          ');
    GOTOXY(20,11);
    WRITE('                                          ');
    GOTOXY(20,12);
    WRITE('                                          ');
    GOTOXY(20,13);
    WRITE('ͼ');
    TEXTCOLOR(8);
    GOTOXY(30,10);
    write('PRINTER NOT FUNCTIONING');
    GOTOXY(29,11);
    WRITE('PRESS ANY KEY TO CONTINUE');
    gotoxy(40,11);
    readkey;
  END
  ELSE
  BEGIN

  write('PRINTING');
  movptr := start;
  while movptr <> NIL do
  begin
   writeln(lst, 'EMPLOYEE CODE: ',movptr^.empcode);
   writeln(lst,chr(10));
   writeln(lst,'EMPLOYEE NAME: ',movptr^.firstname,'                   ADDRESS: ',movptr^.street);
   writeln(lst,'               ',movptr^.lastname,'                  ',movptr^.city);
   writeln(lst,'                                                     ',movptr^.state,',',movptr^.zipcode);
   writeln(lst,chr(10));
   writeln(lst, 'ELIGIBLE FOR REHIRE : ',movptr^.REHIRE);
   writeln(lst, 'DATE OF BIRTH : ',movptr^.dob);
   writeln(lst, 'SOCIAL SECURITY NO. : ',movptr^.ssnum);
   writeln(lst, 'HIRE DATE : ',movptr^.hiredate);
   writeln(lst,chr(10));
   writeln(lst, 'HOME PHONE : ',movptr^.homephone);
   writeln(lst, 'EMERGENCY PHONE : ',movptr^.emphone);
   writeln(lst, 'NOTIFY : ',movptr^.emcontact);
   writeln(lst,chr(10));
   writeln(lst, 'LICENSE NUMBER : ',movptr^.licnum);
   writeln(lst, 'LICENSE EXPIRES : ',movptr^.licexp);
   writeln(lst, 'PHYSICAL EXPIRES : ',movptr^.empcode);
   writeln(lst,chr(10));
   writeln(lst, 'BENEFITS :');        {expand}
   writeln(lst, 'INSURANCE : ');
   writeln(lst, 'VACATION TIME DUE :');
   writeln(lst, 'COMMENT #1 : ',movptr^.COMM1);
   writeln(lst, 'COMMENT #2 : ',movptr^.COMM2);
   writeln(lst, 'COMMENT #3 : ',movptr^.COMM3);
   writeln(lst, 'DATE OF BIRTH : ',movptr^.dob);
   WRITELN(LST,CHR(12));
   movptr := movptr^.next;



  end;
 END;
end;


PROCEDURE DRAWprintMENU;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('              ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(32,4);
    writeln('PRINTMENU #1');
    gotoxy(22,7);
    writeln('1: All Driver Profiles' );
    gotoxy(22,8);
    writeln('2: Driver Profile' );
    gotoxy(22,9);
    writeln('3: Principal Billing Forms' );
    gotoxy(22,10);
    writeln('4: Principal Billing' );
    gotoxy(22,11);
    writeln('5: Employee Benefits' );
    gotoxy(22,12);
    writeln('6: Benefit Changes' );
    gotoxy(22,13);
    writeln('7: Vaction Time Pending' );
    gotoxy(22,14);
    writeln('8: Print Menu #2' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;

PROCEDURE printmenu2;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('              ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(32,4);
    writeln('PRINTMENU #2');
    gotoxy(22,7);
    writeln('1: blank' );
    gotoxy(22,8);
    writeln('2: blank' );
    gotoxy(22,9);
    writeln('3: blank' );
    gotoxy(22,10);
    writeln('4: blank' );
    gotoxy(22,11);
    writeln('5: blank' );
    gotoxy(22,12);
    writeln('6: blank' );
    gotoxy(22,13);
    writeln('7: blank' );
    gotoxy(22,14);
    writeln('8: Print Menu #1' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;

procedure getoption;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;



      '1': begin
            pdall;
            done := true;
          end;



      '2': begin
            done := true;
            show1;
           end;

      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': drawprint2all;
      '9': done := true;
   end;
end;


procedure getoption2;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;
      '1': done := true;
      '2': done := true;
      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': drawprintall;
      '9': done := true;
   end;
end;


procedure makewindow;
{ Make a window, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol-2);
  Height:=(LastRow-2);
  X:=(0);
  Y:=(0);
  Window(X,Y,X+Width,Y+Height);
  if OrigMode = Mono then
  begin
    TextBackground(White);
    TextColor(Black);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(Black);
    TextColor(White);
  end
  else
  begin
    TextBackground(9);
    TextColor(11);
    end; { Init }
end; { MakeWindow }

procedure Makeoptionbar;
{ Make a option bar, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol);
  Height:=(LastRow);
  X:=(0);
  Y:=(0);
  if OrigMode = Mono then
  begin
    TextBackground(black);
    TextColor(white);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(white);
    TextColor(black);
  end
  else
  begin
    TextBackground(9);
    TextColor(11);
    window(lastrow-3,0,lastrow,lastcol);
  GoToXY(1,LastRow);                   { put message line on screen }
  Write('      ','Enter Option Number       ',
        '    Esc-ABORT                 Memory: ',memavail,'   ');
  Dec(LastRow,80 div LastCol);         { don't write on message line }
  end; { Init }
end; { MakeOptionbar }


PROCEDURE DRAWPRINTALL;

begin
  initialize;
  makewindow;
  drawprintmenu;
  makeoptionbar;
  getoption;
end;

PROCEDURE DRAWPRINT2ALL;

begin
  initialize;
  makewindow;
  printmenu2;
  makeoptionbar;
  getoption2;
end;

end.