unit submenus;

interface


uses crt, myutils, getdrfile;

var
  OrigMode,LastCol,LastRow: Word;
  Ch: Char;
  Done: Boolean;

Procedure drawupdate;
Procedure drawbenall;
Procedure drawvacall;
Procedure drawinsall;
Procedure drawpayall;
Procedure security;

Implementation       {------------------------------------}


procedure makewindow;
{ Make a window, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol-2);
  Height:=(LastRow-2);
  X:=(0);
  Y:=(0);
  Window(X,Y,X+Width,Y+Height);
  if OrigMode = Mono then
  begin
    TextBackground(White);
    TextColor(Black);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(Black);
    TextColor(White);
  end
  else
  begin
    TextBackground(9);
    TextColor(11);
    end; { Init }
end; { MakeWindow }

procedure Makeoptionbar;
{ Make a option bar, with background and foreground colors }
var
  X,Y,Width,Height: Word;
begin
  Width:=(LastCol);
  Height:=(LastRow);
  X:=(0);
  Y:=(0);
  if OrigMode = Mono then
  begin
    TextBackground(black);
    TextColor(white);
    ClrScr;
    Window(X+1,Y+1,X+Width-1,Y+Height-1);
    TextBackground(white);
    TextColor(black);
  end
  else
  begin
    TextBackground(9);
    TextColor(11);
    window(lastrow-3,0,lastrow,lastcol);
  GoToXY(1,LastRow);                   { put message line on screen }
    Write('      ','Enter Option Number       ',
        '      ESC - ABORT',       '       Memory: ',memavail,'         ');

  Dec(LastRow,80 div LastCol);         { don't write on message line }
  end; { Init }
end; { MakeOptionbar }



procedure Initialize;
{ Initialize the video mode, LastCol, LastRow }

begin
  CheckBreak:=False;                   { turn off Contrl-C checking }
  OrigMode:=LastMode;                  { Remember original video mode }
  TextMode(CO80);                      { use 43 or 50 lines on EGA/VGA }
  LastCol:=Lo(WindMax)+1;              { get last column, row }
  LastRow:=Hi(WindMax)+1;
end;

PROCEDURE DRAWbenMENU;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('              ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(32,4);
    writeln('BENEFIT MENU');
    gotoxy(22,7);
    writeln('1: View Employee Benefits' );
    gotoxy(22,8);
    writeln('2: Modify Employee Benefits' );
    gotoxy(22,9);
    writeln('3: Purge Period Benefit File' );
    gotoxy(22,10);
    writeln('4: Purge Benefit Change History');      { EXPANSION SLOTS }
    gotoxy(22,11);
    writeln('' );
    gotoxy(22,12);
    writeln('' );
    gotoxy(22,13);
    writeln('' );
    gotoxy(22,14);
    writeln('' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;

PROCEDURE drawvacmenu;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('               ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(32,4);
    writeln('VACATION MENU');
    gotoxy(22,7);
    writeln('1: Update Vacation time.' );
    gotoxy(22,8);
    writeln('2: Change vacation time periods' );
    gotoxy(22,9);
    writeln('3: blank' );
    gotoxy(22,10);
    writeln('4: blank' );
    gotoxy(22,11);
    writeln('5: blank' );
    gotoxy(22,12);
    writeln('6: blank' );
    gotoxy(22,13);
    writeln('7: blank' );
    gotoxy(22,14);
    writeln('8: blank' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;

PROCEDURE DRAWpayMENU;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('              ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(32,4);
    writeln('PAYROLL MENU');
    gotoxy(22,7);
    writeln('1: View Employee Payroll' );
    gotoxy(22,8);
    writeln('2: Modify Employee Payroll' );
    gotoxy(22,9);
    writeln('3: blank' );
    gotoxy(22,10);
    writeln('4: blank' );
    gotoxy(22,11);
    writeln('5: blank' );
    gotoxy(22,12);
    writeln('6: blank' );
    gotoxy(22,13);
    writeln('7: blank' );
    gotoxy(22,14);
    writeln('8: blank' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;


PROCEDURE DRAWinsMENU;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('                ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(31,4);
    writeln('INSURANCE MENU');
    gotoxy(22,7);
    writeln('1: View Employee Benefits' );
    gotoxy(22,8);
    writeln('2: Modify Employee Benefits' );
    gotoxy(22,9);
    writeln('3: Print Employee Benefits' );
    gotoxy(22,10);
    writeln(' ' );                                  { expansion }
    gotoxy(22,11);
    writeln(' ' );
    gotoxy(22,12);
    writeln('' );
    gotoxy(22,13);
    writeln('' );
    gotoxy(22,14);
    writeln('' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;


procedure getbenoption;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;
      '1': begin
             initialize;
             clrscr;
             makewindow;
             textcolor(13);                {*** VIEW *** benefit screen}
             textbackground(black);
             gotoxy(32,2);                    {COMPLETED MODULE..remove}
             getcode;
             benelist;
             DRAWBENALL;
             end;

      '2': begin
             initialize;
             clrscr;
             makewindow;
             textcolor(13);                {*** MODIFY *** benefit screen}
             textbackground(black);
             gotoxy(32,2);
             BENEDIT;
             END;                   {EDIT BENEFITS }
                                    {*** MODIFY *** benefit screen}


      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': DONE := TRUE;
      '9': done := true;
   end;
end;

procedure getinsoption;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;
      '1': done := true;
      '2': done := true;
      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': done := true;
      '9': done := true;
   end;
end;

procedure getpayoption;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;
      '1': done := true;
      '2': done := true;
      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': done := true;
      '9': done := true;
   end;
 end;

procedure getvacoption;

const
 esc = chr(27);

var
 ch :char;

begin
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;
      '1': done := true;
      '2': done := true;
      '3': done := true;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': done := true;
      '9': done := true;
   end;
end;


PROCEDURE BENNEW;                  {EDITS benefit}

var
 ot,r : char;
 ctr : integer;
 CURRPTR: RECPTR;
 counter,x,mover : integer;
 moretosearch : boolean;
 REP, YNSET, CONT : SET OF CHAR;
 RCODE : CHAR;

begin
 YNSET := ['N','n','Y','y'];
 CONT := ['s','S'];
 REP := ['R','r'];
 currptr := listhead;
 if currptr <> NIL then
      begin
      x:=1;
      gotoxy(7,30);                  {FORMAT SCREEN}
      writeln;
      gotoxy(14,4);
      textbackground(black);
      textcolor(13);
      moretosearch := true;
      while (moretosearch) and (currptr <> NIL) do
        if (currptr^.empcode <> coded) then
         currptr := currptr^.next
         else
         moretosearch := false;
         if currptr^.next <> NIL
         then
          if currptr^.empcode <> coded then
           currptr := NIL

       else
    begin
      gotoxy(20,3);
      textcolor(15);
      write(currptr^.empcode);
       gotoxy(20,4);
         while (currptr^.lastname[x] > chr(47)) and (x<20) do
         begin
         write(currptr^.lastname[x]);
         x:= x+1;
         end;
      gotoxy(19+x,4);
      write(', ');
      write(currptr^.firstname);
      drawcombox;   {comments box}
      drbrscr;                                  {draw screen format}
      textcolor(13);
      gotoxy(25,7);                             {insert info}
      write(currptr^.medcst[1],currptr^.medcst[2],currptr^.medcst[3],'.',currptr^.medcst[4],currptr^.medcst[5]);
      gotoxy(62,7);
      write(currptr^.mcafe);
      gotoxy(25,8);
      textcolor(15);
      write(currptr^.dencst[1],currptr^.dencst[2],currptr^.dencst[3],'.',currptr^.dencst[4],currptr^.dencst[5]);
      gotoxy(62,8);
      write(currptr^.dcafe);
      gotoxy(25,9);
      textcolor(13);
      write(currptr^.cancst[1],currptr^.cancst[2],currptr^.cancst[3],'.',currptr^.cancst[4],currptr^.cancst[5]);
      gotoxy(62,9);
      write(currptr^.ccafe);
      gotoxy(25,10);
      textcolor(15);
      write(currptr^.discst[1],currptr^.discst[2],currptr^.discst[3],'.',currptr^.discst[4],currptr^.discst[5]);
      gotoxy(62,10);
      write(currptr^.dicafe);
      gotoxy(25,11);
      textcolor(13);
      write(currptr^.lifcst[1],currptr^.lifcst[2],currptr^.lifcst[3],'.',currptr^.lifcst[4],currptr^.lifcst[5]);
      gotoxy(62,11);
      write(currptr^.lcafe);
      gotoxy(25,12);
      textcolor(15);
      write(currptr^.hoscst[1],currptr^.hoscst[2],currptr^.hoscst[3],'.',currptr^.hoscst[4],currptr^.hoscst[5]);
      gotoxy(62,12);
      write(currptr^.hcafe);
      gotoxy(25,13);
      textcolor(13);
      write(currptr^.intcst[1],currptr^.intcst[2],currptr^.intcst[3],'.',currptr^.intcst[4],currptr^.intcst[5]);
      gotoxy(62,13);
      write(currptr^.icafe);
      gotoxy(25,14);
      textcolor(15);
      write(currptr^.foucst[1],currptr^.foucst[2],currptr^.foucst[3],'.',currptr^.foucst[4],currptr^.foucst[5]);
      gotoxy(62,14);
      write(currptr^.fcafe);
      gotoxy(30,1);
      textcolor(11);
      gotoxy(9,19);
      write(currptr^.bcom1);
      gotoxy(9,20);
      write(currptr^.bcom2);
      gotoxy(9,21);
      write(currptr^.bcom3);

      CTR :=1;
        GOTOXY(25,7);
        OT := CHR(9);
     END;
        WHILE (OT <> CHR(27)) DO
           BEGIN
           CASE CTR OF

              1: BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,7);
                 WRITE('  ');
                 CURRPTR^.MEDCST:=('     ');
                 GOTOXY(25,7);
                 CTR := 2;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,7);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,7);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.MEDCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,7);
                          WRITE(CURRPTR^.MEDCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,7);
                       WRITE('      ');
                       GOTOXY(25,7);
                    IF ( COUNTER = 1) THEN
                       CURRPTR^.MEDCST := '     '
                    ELSE
                    IF (CURRPTR^.MEDCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.MEDCST[1]:= CURRPTR^.MEDCST[COUNTER];
                       CURRPTR^.MEDCST[COUNTER]:= ' ';
                       CURRPTR^.MEDCST := ' ';
                       GOTOXY(25,7);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.MEDCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[1];
    {1 DIGITS}         CURRPTR^.MEDCST[1]:= ' ';
                       GOTOXY(25,7);
                       WRITE('    .',CURRPTR^.MEDCST[5])
                       END
                    ELSE IF (CURRPTR^.MEDCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[2];
    {2 DIGITS}         CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       CURRPTR^.MEDCST[2]:= ' ';
                       GOTOXY(25,7);
                       WRITE('   .',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE IF (CURRPTR^.MEDCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[3];
                       CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[2];
    {3 DIGITS}         CURRPTR^.MEDCST[3]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       CURRPTR^.MEDCST[2]:= ' ';
                       GOTOXY(25,7);
                       WRITE('  ',CURRPTR^.MEDCST[3],'.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE IF (CURRPTR^.MEDCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.MEDCST[5]:= CURRPTR^.MEDCST[4];
    {4 DIGITS}         CURRPTR^.MEDCST[4]:= CURRPTR^.MEDCST[3];
                       CURRPTR^.MEDCST[3]:= CURRPTR^.MEDCST[2];
                       CURRPTR^.MEDCST[2]:= CURRPTR^.MEDCST[1];
                       CURRPTR^.MEDCST[1]:= ' ';
                       GOTOXY(25,7);
                       WRITE(' ',CURRPTR^.MEDCST[2],CURRPTR^.MEDCST[3],'.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,7);
                       WRITE(CURRPTR^.MEDCST[1],CURRPTR^.MEDCST[2],CURRPTR^.MEDCST[3]);
                       WRITE('.',CURRPTR^.MEDCST[4],CURRPTR^.MEDCST[5]);
                       END;
                   GOTOXY(62,7);
                   write('');
                   GOTOXY(62,7);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.MCAFE := R;
                  GOTOXY(62,7);
                  WRITE(CURRPTR^.MCAFE);
                  counter := 8;
                  end;
               end;
              end;


           2: BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,8);
                 WRITE('  ');
                 CURRPTR^.DENCST:=('     ');
                 GOTOXY(25,8);
                 CTR := 3;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,8);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,8);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.DENCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,8);
                          WRITE(CURRPTR^.DENCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,8);
                       WRITE('      ');
                       GOTOXY(25,8);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.DENCST := '     '
                    ELSE
                    IF (CURRPTR^.DENCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.DENCST[1]:= CURRPTR^.DENCST[COUNTER];
                       CURRPTR^.DENCST[COUNTER]:= ' ';
                       CURRPTR^.DENCST := ' ';
                       GOTOXY(25,8);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.DENCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[1];
    {1 DIGITS}         CURRPTR^.DENCST[1]:= ' ';
                       GOTOXY(25,8);
                       WRITE('    .',CURRPTR^.DENCST[5])
                       END
                    ELSE IF (CURRPTR^.DENCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[2];
    {2 DIGITS}         CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       CURRPTR^.DENCST[2]:= ' ';
                       GOTOXY(25,8);
                       WRITE('   .',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE IF (CURRPTR^.DENCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[3];
                       CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[2];
    {3 DIGITS}         CURRPTR^.DENCST[3]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       CURRPTR^.DENCST[2]:= ' ';
                       GOTOXY(25,8);
                       WRITE('  ',CURRPTR^.DENCST[3],'.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE IF (CURRPTR^.DENCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.DENCST[5]:= CURRPTR^.DENCST[4];
    {4 DIGITS}         CURRPTR^.DENCST[4]:= CURRPTR^.DENCST[3];
                       CURRPTR^.DENCST[3]:= CURRPTR^.DENCST[2];
                       CURRPTR^.DENCST[2]:= CURRPTR^.DENCST[1];
                       CURRPTR^.DENCST[1]:= ' ';
                       GOTOXY(25,8);
                       WRITE(' ',CURRPTR^.DENCST[2],CURRPTR^.DENCST[3],'.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,8);
                       WRITE(CURRPTR^.DENCST[1],CURRPTR^.DENCST[2],CURRPTR^.DENCST[3]);
                       WRITE('.',CURRPTR^.DENCST[4],CURRPTR^.DENCST[5]);
                       END;
                   GOTOXY(62,8);
                   write('');
                   GOTOXY(62,8);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.DCAFE := R;
                  GOTOXY(62,8);
                  WRITE(CURRPTR^.DCAFE);
                  counter := 8;
                  END;
                END;
               END;





           3 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,9);
                 WRITE('  ');
                 CURRPTR^.CANCST:=('     ');
                 GOTOXY(25,9);
                 CTR := 4;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,9);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,9);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.CANCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,9);
                          WRITE(CURRPTR^.CANCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,9);
                       WRITE('      ');
                       GOTOXY(25,9);
                     IF ( COUNTER = 1) THEN
                       CURRPTR^.CANCST := '     '
                    ELSE
                    IF (CURRPTR^.CANCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.CANCST[1]:= CURRPTR^.CANCST[COUNTER];
                       CURRPTR^.CANCST[COUNTER]:= ' ';
                       CURRPTR^.CANCST := ' ';
                       GOTOXY(25,9);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.CANCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[1];
    {1 DIGITS}         CURRPTR^.CANCST[1]:= ' ';
                       GOTOXY(25,9);
                       WRITE('    .',CURRPTR^.CANCST[5])
                       END
                    ELSE IF (CURRPTR^.CANCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[2];
    {2 DIGITS}         CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       CURRPTR^.CANCST[2]:= ' ';
                       GOTOXY(25,9);
                       WRITE('   .',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE IF (CURRPTR^.CANCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[3];
                       CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[2];
    {3 DIGITS}         CURRPTR^.CANCST[3]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       CURRPTR^.CANCST[2]:= ' ';
                       GOTOXY(25,9);
                       WRITE('  ',CURRPTR^.CANCST[3],'.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE IF (CURRPTR^.CANCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.CANCST[5]:= CURRPTR^.CANCST[4];
    {4 DIGITS}         CURRPTR^.CANCST[4]:= CURRPTR^.CANCST[3];
                       CURRPTR^.CANCST[3]:= CURRPTR^.CANCST[2];
                       CURRPTR^.CANCST[2]:= CURRPTR^.CANCST[1];
                       CURRPTR^.CANCST[1]:= ' ';
                       GOTOXY(25,9);
                       WRITE(' ',CURRPTR^.CANCST[2],CURRPTR^.CANCST[3],'.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,9);
                       WRITE(CURRPTR^.CANCST[1],CURRPTR^.CANCST[2],CURRPTR^.CANCST[3]);
                       WRITE('.',CURRPTR^.CANCST[4],CURRPTR^.CANCST[5]);
                       END;
                   GOTOXY(62,9);
                   write('');
                   GOTOXY(62,9);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.CCAFE := R;
                  GOTOXY(62,9);
                  WRITE(CURRPTR^.CCAFE);
                  counter := 8;
                END;
               END;
              END;

            4 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,10);
                 WRITE('  ');
                 CURRPTR^.DISCST:=('     ');
                 GOTOXY(25,10);
                 CTR := 5;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,10);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,10);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.DISCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,10);
                          WRITE(CURRPTR^.DISCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,10);
                       WRITE('      ');
                       GOTOXY(25,10);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.DISCST := '     '
                    ELSE
                    IF (CURRPTR^.DISCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.DISCST[1]:= CURRPTR^.DISCST[COUNTER];
                       CURRPTR^.DISCST[COUNTER]:= ' ';
                       CURRPTR^.DISCST := ' ';
                       GOTOXY(25,10);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.DISCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[1];
    {1 DIGITS}         CURRPTR^.DISCST[1]:= ' ';
                       GOTOXY(25,10);
                       WRITE('    .',CURRPTR^.DISCST[5])
                       END
                    ELSE IF (CURRPTR^.DISCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[2];
    {2 DIGITS}         CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       CURRPTR^.DISCST[2]:= ' ';
                       GOTOXY(25,10);
                       WRITE('   .',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE IF (CURRPTR^.DISCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[3];
                       CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[2];
    {3 DIGITS}         CURRPTR^.DISCST[3]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       CURRPTR^.DISCST[2]:= ' ';
                       GOTOXY(25,10);
                       WRITE('  ',CURRPTR^.DISCST[3],'.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE IF (CURRPTR^.DISCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.DISCST[5]:= CURRPTR^.DISCST[4];
    {4 DIGITS}         CURRPTR^.DISCST[4]:= CURRPTR^.DISCST[3];
                       CURRPTR^.DISCST[3]:= CURRPTR^.DISCST[2];
                       CURRPTR^.DISCST[2]:= CURRPTR^.DISCST[1];
                       CURRPTR^.DISCST[1]:= ' ';
                       GOTOXY(25,10);
                       WRITE(' ',CURRPTR^.DISCST[2],CURRPTR^.DISCST[3],'.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,10);
                       WRITE(CURRPTR^.DISCST[1],CURRPTR^.DISCST[2],CURRPTR^.DISCST[3]);
                       WRITE('.',CURRPTR^.DISCST[4],CURRPTR^.DISCST[5]);
                       END;
                   GOTOXY(62,10);
                   write('');
                   GOTOXY(62,10);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.DICAFE := R;
                  GOTOXY(62,10);
                  WRITE(CURRPTR^.DICAFE);
                  counter := 8;
                END;
               END;
              END;


           5 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,11);
                 WRITE('  ');
                 CURRPTR^.LIFCST:=('     ');
                 GOTOXY(25,11);
                 CTR := 6;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,11);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,11);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.LIFCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,11);
                          WRITE(CURRPTR^.LIFCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,11);
                       WRITE('      ');
                       GOTOXY(25,11);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.LIFCST := '     '
                    ELSE
                    IF (CURRPTR^.LIFCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.LIFCST[1]:= CURRPTR^.LIFCST[COUNTER];
                       CURRPTR^.LIFCST[COUNTER]:= ' ';
                       CURRPTR^.LIFCST := ' ';
                       GOTOXY(25,11);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.LIFCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[1];
    {1 DIGITS}         CURRPTR^.LIFCST[1]:= ' ';
                       GOTOXY(25,11);
                       WRITE('    .',CURRPTR^.LIFCST[5])
                       END
                    ELSE IF (CURRPTR^.LIFCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[2];
    {2 DIGITS}         CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       CURRPTR^.LIFCST[2]:= ' ';
                       GOTOXY(25,11);
                       WRITE('   .',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE IF (CURRPTR^.LIFCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[3];
                       CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[2];
    {3 DIGITS}         CURRPTR^.LIFCST[3]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       CURRPTR^.LIFCST[2]:= ' ';
                       GOTOXY(25,11);
                       WRITE('  ',CURRPTR^.LIFCST[3],'.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE IF (CURRPTR^.LIFCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.LIFCST[5]:= CURRPTR^.LIFCST[4];
    {4 DIGITS}         CURRPTR^.LIFCST[4]:= CURRPTR^.LIFCST[3];
                       CURRPTR^.LIFCST[3]:= CURRPTR^.LIFCST[2];
                       CURRPTR^.LIFCST[2]:= CURRPTR^.LIFCST[1];
                       CURRPTR^.LIFCST[1]:= ' ';
                       GOTOXY(25,11);
                       WRITE(' ',CURRPTR^.LIFCST[2],CURRPTR^.LIFCST[3],'.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,11);
                       WRITE(CURRPTR^.LIFCST[1],CURRPTR^.LIFCST[2],CURRPTR^.LIFCST[3]);
                       WRITE('.',CURRPTR^.LIFCST[4],CURRPTR^.LIFCST[5]);
                       END;
                   GOTOXY(62,11);
                   write('');
                   GOTOXY(62,11);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.LCAFE := R;
                  GOTOXY(62,11);
                  WRITE(CURRPTR^.LCAFE);
                  counter := 8;
                END;
               END;
              END;

           6 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,12);
                 WRITE('  ');
                 CURRPTR^.HOSCST:=('     ');
                 GOTOXY(25,12);
                 CTR := 7;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,12);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,12);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.HOSCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,12);
                          WRITE(CURRPTR^.HOSCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,12);
                       WRITE('      ');
                       GOTOXY(25,12);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.HOSCST := '     '
                    ELSE
                    IF (CURRPTR^.HOSCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.HOSCST[1]:= CURRPTR^.HOSCST[COUNTER];
                       CURRPTR^.HOSCST[COUNTER]:= ' ';
                       CURRPTR^.HOSCST := ' ';
                       GOTOXY(25,12);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.HOSCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[1];
    {1 DIGITS}         CURRPTR^.HOSCST[1]:= ' ';
                       GOTOXY(25,12);
                       WRITE('    .',CURRPTR^.HOSCST[5])
                       END
                    ELSE IF (CURRPTR^.HOSCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[2];
    {2 DIGITS}         CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       CURRPTR^.HOSCST[2]:= ' ';
                       GOTOXY(25,12);
                       WRITE('   .',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE IF (CURRPTR^.HOSCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[3];
                       CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[2];
    {3 DIGITS}         CURRPTR^.HOSCST[3]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       CURRPTR^.HOSCST[2]:= ' ';
                       GOTOXY(25,12);
                       WRITE('  ',CURRPTR^.HOSCST[3],'.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE IF (CURRPTR^.HOSCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.HOSCST[5]:= CURRPTR^.HOSCST[4];
    {4 DIGITS}         CURRPTR^.HOSCST[4]:= CURRPTR^.HOSCST[3];
                       CURRPTR^.HOSCST[3]:= CURRPTR^.HOSCST[2];
                       CURRPTR^.HOSCST[2]:= CURRPTR^.HOSCST[1];
                       CURRPTR^.HOSCST[1]:= ' ';
                       GOTOXY(25,12);
                       WRITE(' ',CURRPTR^.HOSCST[2],CURRPTR^.HOSCST[3],'.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,12);
                       WRITE(CURRPTR^.HOSCST[1],CURRPTR^.HOSCST[2],CURRPTR^.HOSCST[3]);
                       WRITE('.',CURRPTR^.HOSCST[4],CURRPTR^.HOSCST[5]);
                       END;
                   GOTOXY(62,12);
                   write('');
                   GOTOXY(62,12);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.HCAFE := R;
                  GOTOXY(62,12);
                  WRITE(CURRPTR^.HCAFE);
                  counter := 8;
                END;
               END;
             END;

           7 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,13);
               WRITE('  ');
                 CURRPTR^.INTCST:=('     ');
                 GOTOXY(25,13);
                 CTR := 8;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,13);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,13);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.INTCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,13);
                          WRITE(CURRPTR^.INTCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,13);
                       WRITE('      ');
                       GOTOXY(25,13);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.INTCST := '     '
                    ELSE
                    IF (CURRPTR^.INTCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.INTCST[1]:= CURRPTR^.INTCST[COUNTER];
                       CURRPTR^.INTCST[COUNTER]:= ' ';
                       CURRPTR^.INTCST := ' ';
                       GOTOXY(25,13);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.INTCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[1];
    {1 DIGITS}         CURRPTR^.INTCST[1]:= ' ';
                       GOTOXY(25,13);
                       WRITE('    .',CURRPTR^.INTCST[5])
                       END
                    ELSE IF (CURRPTR^.INTCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[2];
    {2 DIGITS}         CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       CURRPTR^.INTCST[2]:= ' ';
                       GOTOXY(25,13);
                       WRITE('   .',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE IF (CURRPTR^.INTCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[3];
                       CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[2];
    {3 DIGITS}         CURRPTR^.INTCST[3]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       CURRPTR^.INTCST[2]:= ' ';
                       GOTOXY(25,13);
                       WRITE('  ',CURRPTR^.INTCST[3],'.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE IF (CURRPTR^.INTCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.INTCST[5]:= CURRPTR^.INTCST[4];
    {4 DIGITS}         CURRPTR^.INTCST[4]:= CURRPTR^.INTCST[3];
                       CURRPTR^.INTCST[3]:= CURRPTR^.INTCST[2];
                       CURRPTR^.INTCST[2]:= CURRPTR^.INTCST[1];
                       CURRPTR^.INTCST[1]:= ' ';
                       GOTOXY(25,13);
                       WRITE(' ',CURRPTR^.INTCST[2],CURRPTR^.INTCST[3],'.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,13);
                       WRITE(CURRPTR^.INTCST[1],CURRPTR^.INTCST[2],CURRPTR^.INTCST[3]);
                       WRITE('.',CURRPTR^.INTCST[4],CURRPTR^.INTCST[5]);
                       END;
                   GOTOXY(62,13);
                   write('');
                   GOTOXY(62,13);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CURRPTR^.ICAFE := R;
                  GOTOXY(62,13);
                  WRITE(CURRPTR^.ICAFE);
                  counter :=8;
                END;
               END;
             END;



           8 : BEGIN
              MOVER := 1;
              COUNTER :=1;
              GOTOXY(25,14);
               WRITE('  ');
                 CURRPTR^.FOUCST:=('     ');
                 GOTOXY(25,14);
                 CTR := 12;
                 WHILE COUNTER < 7 DO
                    BEGIN
                    R:=READKEY;
                    IF (COUNTER =6) THEN
                       BEGIN
                       WHILE (R <> CHR(13)) DO
                         BEGIN
                         SOUND(1140);
                         DELAY(400);
                         NOSOUND;
                         R := READKEY;
                         END;
                       COUNTER := 7;
                       END;
                    IF (R=CHR(8)) AND (COUNTER<7) AND (COUNTER >1) THEN
                       BEGIN
                       GOTOXY((25+COUNTER)-2,14);
                       WRITE('');
                       GOTOXY((25+COUNTER)-2,14);
                       COUNTER := COUNTER-1;
                       END;
        
                    IF (R > CHR(57)) OR (R < CHR(48)) AND NOT (R = CHR(13)) AND (R <> CHR(8)) THEN
                       BEGIN
                       SOUND(1150);
                       DELAY(400);
                       NOSOUND;
                       END
                    ELSE IF (R < CHR(58)) AND (R > CHR(47)) THEN
                       BEGIN
                       IF (COUNTER < 6) THEN
                          BEGIN
                          CURRPTR^.FOUCST[COUNTER] := R;
                          GOTOXY(24+COUNTER,14);
                          WRITE(CURRPTR^.FOUCST[COUNTER]);
                          COUNTER := COUNTER +1;
                          END;
                        END;
                    IF (R = CHR(13)) THEN
                       BEGIN
                       GOTOXY(25,14);
                       WRITE('      ');
                       GOTOXY(25,14);
                        IF ( COUNTER = 1) THEN
                       CURRPTR^.FOUCST := '     '
                    ELSE
                    IF (CURRPTR^.FOUCST[1] = ' ') THEN
                       BEGIN
    {0 DIGITS}         CURRPTR^.FOUCST[1]:= CURRPTR^.FOUCST[COUNTER];
                       CURRPTR^.FOUCST[COUNTER]:= ' ';
                       CURRPTR^.FOUCST := ' ';
                       GOTOXY(25,14);
                       WRITE('   .  ');
                       END
                    ELSE IF (CURRPTR^.FOUCST[2] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[1];
    {1 DIGITS}         CURRPTR^.FOUCST[1]:= ' ';
                       GOTOXY(25,14);
                       WRITE('    .',CURRPTR^.FOUCST[5])
                       END
                    ELSE IF (CURRPTR^.FOUCST[3] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[2];
    {2 DIGITS}         CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       CURRPTR^.FOUCST[2]:= ' ';
                       GOTOXY(25,14);
                       WRITE('   .',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE IF (CURRPTR^.FOUCST[4] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[3];
                       CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[2];
    {3 DIGITS}         CURRPTR^.FOUCST[3]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       CURRPTR^.FOUCST[2]:= ' ';
                       GOTOXY(25,14);
                       WRITE('  ',CURRPTR^.FOUCST[3],'.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE IF (CURRPTR^.FOUCST[5] = ' ') THEN
                       BEGIN
                       CURRPTR^.FOUCST[5]:= CURRPTR^.FOUCST[4];
    {4 DIGITS}         CURRPTR^.FOUCST[4]:= CURRPTR^.FOUCST[3];
                       CURRPTR^.FOUCST[3]:= CURRPTR^.FOUCST[2];
                       CURRPTR^.FOUCST[2]:= CURRPTR^.FOUCST[1];
                       CURRPTR^.FOUCST[1]:= ' ';
                       GOTOXY(25,14);
                       WRITE(' ',CURRPTR^.FOUCST[2],CURRPTR^.FOUCST[3],'.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END
                     ELSE
                       BEGIN
                       GOTOXY(25,14);
                       WRITE(CURRPTR^.FOUCST[1],CURRPTR^.FOUCST[2],CURRPTR^.FOUCST[3]);
                       WRITE('.',CURRPTR^.FOUCST[4],CURRPTR^.FOUCST[5]);
                       END;
                   GOTOXY(62,14);
                   write('');
                   GOTOXY(62,14);
                   R:= READKEY;
                   WHILE NOT (R IN YNSET) DO
                     BEGIN
                     SOUND(1100);
                     DELAY(300);
                     NOSOUND;
                     R:= READKEY;
                     END;
                  CTR:=9;
                  CURRPTR^.FCAFE := R;
                  GOTOXY(62,14);
                  WRITE(CURRPTR^.FCAFE);
                  counter := 8;
                END;
               END;
             END;



         9: BEGIN
           OT := CHR(27);
           gotoxy(17,23);
           IF (MORETOSEARCH = TRUE) THEN
           RCODE := '3'
           ELSE
           BEGIN
           TEXTBACKGROUND(7);
           TEXTCOLOR(BLACK);
           write('PRESS  S  TO SAVE AND RETURN TO MENU');
           TEXTBACKGROUND(BLACK);
           TEXTCOLOR(15);
           GOTOXY(39,24);
           TEXTCOLOR(14);
           WRITE('');
           GOTOXY(39,24);
           RCODE := READKEY;
           CLRSCR;
           END;
          END;
         END;
       END;
     END;

END;





procedure getupdateoption;

const
 esc = chr(27);

var
 godel,ch,ch2 :char;
 delchars : set of char;
 scode : string[6];
 index : integer;

begin
 delchars := ['n','N','y','Y'];
 textcolor(11);
 textbackground(9);
 gotoxy(27,lastrow+1);
 ch:= readkey;
 while not (ch in [esc,'1','2','3','4','5','6','7','8','9']) do
  begin
   gotoxy(7,lastrow+1);
   write('Invalid Choice Try Again ');
   ch := readkey;
 end;
   write(ch);
   case ch of
      esc: done := true;        {modify existing employee}
      '1': begin
            initialize;
            clrscr;
            makewindow;
            textcolor(13);
            textbackground(black);
            gotoxy(32,2);
            getcode;
            modifylist;
            index := 1;
            textbackground(black);
           end;
      '2': begin
            initialize;
            clrscr;
            makewindow;
            gotoxy(32,2);
            getcode;
            showlist;
            gotoxy(1,1);
            textcolor(red);
            textbackground(black);
            write('       ARE YOU SURE YOU WANT TO DELETE THIS EMPLOYEE? Y/N : ');
            gotoxy(1,50);
            godel := 'Z';
            while NOT (godel IN delchars) do
               begin
                 gotoxy(1,50);
                 godel := readkey;
               end;
                 if ((godel = 'y') or (godel = 'Y')) then
                   delemp1
                 else
                   begin
                     gotoxy(1,1);
                     writeln('                                                                     ');
                     gotoxy(1,1);
                     writeln('     RECORD WAS NOT DELETED...PRESS A KEY TO CONTINUE.');
                     readkey;
                   end;

           end;


      '3': begin
            initialize;
            clrscr;
            makewindow;
            gotoxy(32,2);
            getcode;
            getnewemp;
            clrscr;
            bennew;
           end;
      '4': done := true;
      '5': done := true;
      '6': done := true;
      '7': done := true;
      '8': done := true;
      '9': done := true;
   end;
end;




PROCEDURE DRAWbenALL;

begin
  initialize;
  makewindow;
  drawbenmenu;
  makeoptionbar;
  getbenoption;
end;



PROCEDURE DRAWvacALL;

begin
  initialize;
  makewindow;
  drawvacmenu;
  makeoptionbar;
  getvacoption;
end;

PROCEDURE DRAWpayALL;

begin
  initialize;
  makewindow;
  drawpaymenu;
  makeoptionbar;
  getpayoption;
end;

PROCEDURE DRAWinsALL;

begin
  initialize;
  makewindow;
  drawinsmenu;
  makeoptionbar;
  getinsoption;
end;

Procedure security;

const
  code = 'judy123.';
  code2 = 'JUDY123.';

var
 COUNT : INTEGER;
 seccode : string[8];
 index   : integer;
 again   : boolean;

begin
 index := 1;
 COUNT :=1;
 initialize;
 gotoxy(23,2);
 textcolor(15);
 writeln('Welcome to Office Doctor');
 delay(1000);
 gotoxy(23,2);
 writeln('Raymond Cossette Trucking');
  seccode := 'xxxxxxxx';
 makewindow;
 gotoxy(15,10);
 textcolor(13);
 textbackground(black);
 writeln('ͻ');
 gotoxy(15,11);
 writeln('                                                ');
 gotoxy(15,12);
 writeln('ͼ');
  gotoxy(17,11);
  textcolor(13);
 write('ENTER PASSWORD:');
 repeat
 index := 1;
 while (index < 9 ) do
 begin
   gotoxy(34+index,11);
   seccode[index] := readkey;
   textcolor(14);
   write('');
   textcolor(28);
   index := index + 1;
 end;
 if (seccode <> code) and (seccode <> code2)  then
   begin
    gotoxy(35,11);
    write('        ');
    again:= true;
    gotoxy(17,11);
    textcolor(28);
    write('INVALID RETRY :');
    COUNT := COUNT +1;
    IF COUNT > 4 THEN
    BEGIN
     TEXTCOLOR(15);
     TEXTBACKGROUND(BLACK);
     CLRSCR;
     WRITE('THIS UNAUTHORIZED ACCESS ATTEMPT HAS BEEN LOGGED.');
     HALT;
     END;
    sound(150);
    delay(400);
    nosound;
   end
  else
    begin
     again := false;
     gotoxy(17,11);
     textcolor(10);
     write('PASSWORD ACCEPTED.....          ');
     gotoxy(40,11);
     textcolor(26);
     write('WAIT');
     delay(500);
    end;

until again = false;
end;


PROCEDURE DRAWupdatemenu;

 begin
    gotoxy(25,1);
    textcolor(15);
    textbackground(black);
    writeln('RAYMOND COSSETTE TRUCKING');
    textcolor(11);
    textbackground(black);
    gotoxy(15,4);
    writeln('                      ͻ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('                                                          ');
    writeln('              ͼ');
    textcolor(13);                     {text color set to purple}
    textbackground(black);             { always black background}
    gotoxy(28,4);
    writeln('UPDATE EMPLOYEE INFO');
    gotoxy(22,7);
    writeln('1: Modify Existing Employee' );
    gotoxy(22,8);
    writeln('2: Delete Existing Employee' );
    gotoxy(22,9);
    writeln('3: Add New Employee To List' );
    gotoxy(22,10);
    writeln('4: blank' );
    gotoxy(22,11);
    writeln('5: blank' );
    gotoxy(22,12);
    writeln('6: blank' );
    gotoxy(22,13);
    writeln('7: blank' );
    gotoxy(22,14);
    writeln('8: blank' );
    gotoxy(22,15);
    writeln('9: Return to Main Menu' );
    gotoxy(22,16);
   END;


PROCEDURE DRAWupdate;

begin
  initialize;
  makewindow;
  drawupdatemenu;
  makeoptionbar;
  getupdateoption;
end;


end.      {of unit}