{
Custom Characters 2.3

(C) 1993 Steve Goldsmith
All Rights Reserved

VGA character generator file object.  All CGF header fields must be set
and a buffer containing character patterns allocated before writing
character generator files (CGF) to disk.  The read method will allocate
the buffer for you.  You are responsible for deallocating the buffer.
}

unit VGACGFil;

{$I APP.INC}

interface

uses

  Dos, Objects, VGA;

const

{cgf version 01.00}

  cgfVersion = $0100;

{cgf internal errors}

  cgfMemAlloc      = -100;
  cgfNotCGFformat  = -101;

type

{128 byte cgf header record}

  cgfHeader = record
    Version,
    Height,
    StartChr,
    TotalChrs : word;
    Filler : array[0..119] of byte; {save for future expansion}
  end;

  PChrGenFile = ^TChrGenFile;
  TChrGenFile = object (TObject)
    IoError : integer;
    ChrTableSize : word;
    CGFFile : file;
    Header : cgfHeader;
    ChrTablePtr : vgaChrTablePtr;
    constructor Init;
    destructor Done; virtual;
    procedure FreeChrTable;
    procedure OpenRead (FileName : PathStr);
    procedure ReadChrTable;
    procedure OpenWrite (FileName : PathStr);
    procedure WriteChrTable;
    procedure GetFontTable (ChrTable,StartChr,TotalChrs,Height : word);
  end;

implementation

end.
